/*  cms-db  Copyright (C) 2007-2010 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */

/* Returns a XMLHttpRequest object or false */
function initAjax() {
	var request = false;
	if (window.XMLHttpRequest) {
		request = new XMLHttpRequest();
		if (request.overrideMimeType) {
			request.overrideMimeType("text/plain");
		}
	} else if (window.ActiveXObject) {
		try {
			request = new ActiveXObject("Msxml2.XMLHTTP");
		} catch (e) {
			try {
				request = new ActiveXObject("Microsoft.XMLHTTP");
			} catch (e) {}
		}
	} else {
		window.status = "AJAX not availavle";
	}
	return request;
}
/* 
 * Sends a GET request using:
 *  - the specified XMLHttpObject (request)
 *  - the given url
 * If func is not false, it is called with the response text or false on error
 */
function doGETRequest(request, func, url) {
	if (request) {
		request.open("GET", url, true);
		request.onreadystatechange = function() {
			if (request.readyState == 4) {
				if (request.status == 200) {
					if (func) {
						try {
							func(request.responseText);
						} catch (e) {
							var gthis = (function(){return this;})();
							gthis[func](request.responseText);
						}
					}
				} else {
					window.status = "AJAX response error: "+request.status;
					if (func) {
						try {
							func(false);
						} catch (e) {
							var gthis = (function(){return this;})();
							gthis[func](false);
						}
					}
				}
			}
		}
		request.send(null);
	}
}
/* As doGetRequest, but accepts an additional parameter which specifies the POST parameters */
function doPOSTRequest(request, func, url, parameters) {
	if (request) {
		request.open("POST", url, true);
		request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		request.setRequestHeader("Content-length", parameters.length);
		request.setRequestHeader("Connection", "close");
		request.onreadystatechange = function() {
			if (request.readyState == 4) {
				if (request.status == 200) {
					if (func) {
						try {
							func(request.responseText);
						} catch (e) {
							var gthis = (function(){return this;})();
							gthis[func](request.responseText);
						}
					}
				} else {
					window.status = "AJAX response error: "+request.status;
					if (func) {
						try {
							func(false);
						} catch (e) {
							var gthis = (function(){return this;})();
							gthis[func](false);
						}
					}
				}
			}
		}
		request.send(parameters);
	}
}
