<?php
/*  cms-db  Copyright (C) 2007-2010 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */

define('cms-db', 'backend');

include('checkuser.inc.php');
checkuser('pages');
include('locale.inc.php');
$locale = new LocalizingClass('pages');

require_once('../functions_url.inc.php');

$path = get_filename_from_url($_GET['file']);
if ($path === false) {
	die('Error: The page couldn\'t be found in the URL index.');
}
$path = '../data/pages'.$path;

if (isset($_POST['button'])) {
	$attributes = array();
	foreach($_POST as $attr => $value) {
		if (substr($attr, 0, 5) == 'attr_' && $value != '') {
			$attr = substr($attr, 5);
			if (substr($attr, 0, 5) == 'meta_') {
				$attr = substr($attr, 0, 4).'//'.substr($attr, 5);
			}
			$attributes[] = $attr.'//'.$value;
		}
	}
	$_content = file_get_contents($path);
	$_content = explode("\n".'EOC'."\n", $_content, 2);
	$content = $_content[0];
	unset($_content);
	$content = $content."\n".'EOC'."\n".implode("\\\\\n", $attributes);
	file_put_contents($path, $content);
}
$pagetitle = basename(dirname($path));
$pagetitle = substr($pagetitle, 3);
$pagetitle = str_replace('_', ' ', $pagetitle);
$pagetitle = str_replace('"SLASH', '/', $pagetitle);
$pagetitle = str_replace('AND', '&', $pagetitle);
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title><?php locale('title_attributes') ?></title>
		<meta http-equiv="content-type" content="text/html; charset=utf-8" />
		<link rel="stylesheet" type="text/css" href="style.css">
		<link rel="stylesheet" type="text/css" href="<?php include('mobile.inc.php'); echo mobile() ? 'style-extra-mobile.css' : 'style-extra.css'; ?>" />
		<script src="jquery.js" type="text/javascript"></script>
		<script src="anchormenu.js" type="text/javascript"></script>
	</head>
	<body>

		<h1><?php locale('title_attributes') ?>: <?php echo htmlspecialchars($pagetitle) ?></h1>

		<div class="anchormenu"><span class="leftcorner">&nbsp;</span><ul><li><a href="#editattr" class="nonewtab"><?php locale('link_editattr') ?></a></li><li><a href="#addattr" class="nonewtab"><?php locale('link_addattr') ?></a></li></ul><span class="rightcorner">&nbsp;</span></div>

		<div id="editattr">

			<h2><?php locale('title_editattr') ?></h2>

			<p>
				<?php locale('desc_delete-attr') ?>
			</p>

			<form action="attributes.php?file=<?php echo $_GET['file'] ?>&<?php echo SID; csrf_protection_get_html() ?>" method="post">
				<?php

				$_content = file_get_contents($path);
				$_content = explode("\n".'EOC'."\n", $_content, 2);
				$_attributes = $_content[1];
				unset($_content);
				$_attributes = explode("\\\\\n", $_attributes);
				$attributes = array();
				foreach ($_attributes as $attribute) {
					if ($attribute != '') {
						$attributes[] = explode('//', $attribute, 2);
					}
				}
				unset($_attributes);


				foreach($attributes as $attr) {
					list($attr_name, $attr_data) = $attr;
					if ($attr_name == 'meta') {
						list($attr_type, $attr_data) = explode('//', $attr_data, 2);
						echo '<h3>';
						printf(locale('label_attr-meta', true), $attr_type);
						if ($attr_type == 'keywords') echo ' '.locale('desc_comma-separated', true);
						echo '</h3>';
						echo '<p>';
						if ($attr_type != 'description') {
							echo '<input type="text" name="attr_meta_'.$attr_type.'" value="'.$attr_data.'" style="width: 99%" />';
						} else {
							echo '<textarea rows="3" cols="80" name="attr_meta_'.$attr_type.'">'.$attr_data.'</textarea>';
						}
						echo '</p>';
					} else {
						echo '<h3>';
						printf(locale('label_attr-custom', true), $attr_name);
						echo '</h3>';
						echo '<p>';
						echo '<textarea rows="5" cols="80" name="attr_'.$attr_name.'">'.$attr_data.'</textarea>';
						echo '</p>';
					}
				}

				if (count($attributes) == 0) {
					echo '<p>';
					echo '<i>'.locale('desc_no-attr', true).'</i>';
					echo '</p>';
				}

				echo '<p>';
				if (count($attributes) > 0) {
					echo '<input type="submit" name="button" value="'.locale('button_save', true).'" />';
				} else {
					echo '<input type="submit" name="button" value="'.locale('button_save', true).'" disabled="disabled" />';

				}
				echo '</p>';

				?>
			</form>

		</div>

		<div id="addattr">

			<h2><?php locale('title_addattr') ?></h2>

			<p>
				<?php locale('desc_save-before-adding') ?>
			</p>

			<h3><?php locale('title_attr-meta') ?></h3>

			<form action="addattr.php?<?php echo SID; csrf_protection_get_html() ?>" method="post">
				<input type="hidden" name="file" value="<?php echo $_GET['file'] ?>" />
				<input type="hidden" name="type" value="meta" />
				<p>
					<?php locale('label_attr-meta-type') ?>
					<select name="subtype">
						<option value="description">description</option>
						<option value="keywords">keywords</option>
					</select>
					<input type="submit" name="button" value="<?php locale('button_add') ?>" />
				</p>
			</form>

			<h3><?php locale('title_attr-custom') ?></h3>

			<form action="addattr.php?<?php echo SID; csrf_protection_get_html() ?>" method="post">
				<input type="hidden" name="file" value="<?php echo $_GET['file'] ?>" />
				<p>
					<?php locale('label_attr-custom-identifier') ?>
					<input type="text" name="type" value="" />
					<input type="submit" name="button" value="<?php locale('button_add') ?>" />
				</p>
			</form>
		</div>

	</body>
</html>
