<?php
/*  cms-db  Copyright (C) 2007-2010 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */

define('cms-db', 'backend');

include('checkuser.inc.php');
checkuser('root');
include('locale.inc.php');
$locale = new LocalizingClass('backup-action');
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title><?php locale('title_backup-unzip') ?></title>
		<meta http-equiv="content-type" content="text/html; charset=utf-8" />
		<link rel="stylesheet" type="text/css" href="style.css">
	</head>
	<body>
<?php
/* Start of compatibility functions for backup version 0.5 */

function updatePages() {
	include('./update/convert_pages_to_sections.inc.php');
	convert_pages_to_sections();

	include('urlindex.inc.php');
	generate_urlindex();
}

function updateStats() {
	if (file_exists('../data/stats/unknown.list')) {
		unlink('../data/stats/unknown.list');
	}
	$oldformat = false;
	$handle = opendir('../data/stats/browser');
	while (false !== ($file = readdir ($handle))) {
		if ($file != "." && $file != "..") {
			$contents = file_get_contents('../data/stats/browser/'.$file);
			if ($oldformat == true or substr_count($contents, "\n") != 2) {
				unlink('../data/stats/browser/'.$file);
				$oldformat = true;
			}
		}
	}
	closedir($handle);
	if ($oldformat == true) {
		$handle = opendir('../data/stats/os');
		while (false !== ($file = readdir ($handle))) {
			if ($file != "." && $file != "..") {
				unlink('../data/stats/os/'.$file);
			}
		}
		closedir($handle);
		if (file_exists('../data/stats/ip.list')) {
			unlink('../data/stats/ip.list');
		}
	}
}

function updateNeededFiles() {
	// add $newwindows if not present
	$newwindows = '';
	$cache = '';
	$xhtml = 'on';
	include('../data/settings/common.inc.php');
	file_put_contents('../data/settings/common.inc.php', '<?php
	$hinweis = "'.$hinweis.'";
	$home = "'.$home.'";
	$newwindows = "'.$newwindows.'";
	$cache = "'.$cache.'";
	$xhtml = "'.$xhtml.'";
	?>');

	// ensure that the right version is set (for later update)
	file_put_contents('../data/version.txt', '0.7.5');

	// convert passwords
	include('./update/convert_passwords_to_hashes.inc.php');
	convert_passwords_to_hashes();

	// create .htaccess for files if not present
	file_put_contents('../data/files/.htaccess', 'Allow from All');
}

/* End of compatibility functions for backup version 0.5 */

function delete_recursive($dir, $unlink_dir = false, $dontdelete = '') {
	if ($handle = opendir($dir)) {
		while (false !== ($file = readdir($handle))) {
			if($file != "." && $file != "..") {
				if (is_file($dir.'/'.$file)) {
					unlink($dir.'/'.$file);
				} elseif (is_dir($dir.'/'.$file) && $dontdelete != $dir.'/'.$file) {
					delete_recursive($dir.'/'.$file, true);
				}
			}
		}
		closedir($handle);
		if ($unlink_dir == true) {
			rmdir($dir);
		}
	}
}

function copy_recursive($src, $dest, $dontcopy = '') {
	if ($handle = opendir($src)) {
		if (!is_dir($dest)) {
			mkdir($dest);
		}
		while (false !== ($file = readdir($handle))) {
			if($file != "." && $file != "..") {
				if (is_file($src.'/'.$file)) {
					copy($src.'/'.$file, $dest.'/'.$file);
				} elseif (is_dir($src.'/'.$file) && $dontcopy != $src.'/'.$file) {
					copy_recursive($src.'/'.$file, $dest.'/'.$file);
				}
			}
		}
		closedir($handle);
	}
}

if (isset($_POST['submit'])) {

	echo '<h1>'.locale('title_backup-unzip',true).'</h1>';

	if (is_uploaded_file($_FILES['file']['tmp_name'])) {

		if (substr($_FILES['file']['name'], -4, 4) == '.zip') {

			if (copy($_FILES['file']['tmp_name'], '../data/backup/'.$_FILES['file']['name'])) {

				include('./pclzip-2-6/pclzip.lib.php');

				$zip = new PclZip('../data/backup/'.$_FILES['file']['name']);
				$prop = $zip->properties();
				if ($prop['status'] == 'ok') {

					$list = $zip->listContent();

					$signature = explode('/', $list[0]['filename']);
					$signature = $signature[0];

					if ($signature == 'cms-db_backup_complete_v0.5' or $signature == 'cms-db_backup_complete_v0.7.6') {
						$backup_dir_pages = '../data/backup/extract_'.uniqid();
						copy_recursive('../data/pages', $backup_dir_pages);
						delete_recursive('../data/pages');
						$backup_dir_files = '../data/backup/extract_'.uniqid();
						copy_recursive('../data/files', $backup_dir_files);
						delete_recursive('../data/files');
						$backup_dir_includes = '../data/backup/extract_'.uniqid();
						copy_recursive('../data/includes', $backup_dir_includes);
						delete_recursive('../data/includes');
						$backup_dir_users = '../data/backup/extract_'.uniqid();
						copy_recursive('../data/users', $backup_dir_users);
						delete_recursive('../data/users');
						$backup_dir_counter = '../data/backup/extract_'.uniqid();
						copy_recursive('../data/counter', $backup_dir_counter);
						delete_recursive('../data/counter');
						$backup_dir_blogarticles = '../data/backup/extract_'.uniqid();
						copy_recursive('../data/blog/articles', $backup_dir_blogarticles);
						delete_recursive('../data/blog/articles');
						$backup_dir_blogtags = '../data/backup/extract_'.uniqid();
						copy_recursive('../data/blog/tags', $backup_dir_blogtags);
						delete_recursive('../data/blog/tags');

						$result = $zip->extract(PCLZIP_OPT_PATH, '../data',
							PCLZIP_OPT_REMOVE_PATH, $signature,
							PCLZIP_OPT_REPLACE_NEWER);
						if ($result == 0) {
							die('<p>'.locale('title_error',true).': '.$zip->errorInfo().'</p>');

							copy_recursive($backup_dir_pages, '../data/pages');
							copy_recursive($backup_dir_files, '../data/files');
							copy_recursive($backup_dir_includes, '../data/includes');
							copy_recursive($backup_dir_users, '../data/users');
							copy_recursive($backup_dir_counter, '../data/users');
							copy_recursive($backup_dir_blogarticles, '../data/blog/articles');
							copy_recursive($backup_dir_blogtags, '../data/blog/tags');
							delete_recursive('../data/backup/');
						}
						/*echo '<p>';
						for ($i=0; $i<sizeof($result); $i++) {
							echo 'extracting "'.$result[$i]['stored_filename'].'" to "'.$result[$i]['filename'].'" ... '.$result[$i]['status'].'<br />';
						}
						echo '</p>';*/
						delete_recursive('../data/cache');
						delete_recursive('../data/backup/');
						echo '<p>'.locale('desc_unzip-ready',true).'</p>';
						if ($signature == 'cms-db_backup_complete_v0.5') {
							updatePages();
							updateStats();
							updateNeededFiles();
						}
						$version_installed = file_get_contents('../data/version.txt');
						$version_available = file_get_contents('./update/version.txt');
						if ($version_installed != $version_available) {
							echo '<p>'.locale('desc_update-needed',true).'</p>';
							echo '<p><a class="nonewtab" href="update/index.php?nolink=true&'.SID.csrf_protection_get_html_ret().'">'.locale('link_next',true).'</a></p>';						
						} else {
							echo '<p><a class="nonewtab" href="backup_unzip.php?'.SID.csrf_protection_get_html_ret().'">'.locale('link_back',true).'</a></p>';
						}
					} else {
						echo '<p>'.locale('desc_unknown-format',true).'</p>';
						unlink('../data/backup/'.$_FILES['file']['name']);
						echo '<p><a class="nonewtab" href="backup_unzip.php?'.SID.csrf_protection_get_html_ret().'">'.locale('link_back',true).'</a></p>';
					}

				} else {
					echo '<p>'.locale('desc_archive-corrupt',true).' ('.locale('title_error',true).': '.$zip->errorInfo().')</p><p><a href="backup_unzip.php?'.SID.csrf_protection_get_html_ret().'">'.locale('link_back',true).'</a></p>';
					unlink('../data/backup/'.$_FILES['file']['name']);
				}

			} else {
				echo '<p>'.locale('desc_copy-error',true).'</p><p><a href="backup_unzip.php?'.SID.csrf_protection_get_html_ret().'">'.locale('link_back',true).'</a></p>';
			}

		} elseif (substr($_FILES['file']['name'], -5, 5) == '.cdba') {

			if (copy($_FILES['file']['tmp_name'], '../data/backup/'.$_FILES['file']['name'])) {

				include('archive.inc.php');
				$a = new unArchive('../data/backup/'.$_FILES['file']['name']);
				if ($a->readHeader() && trim($a->comment) == 'cms -db complete backup v0.7.5') {
					$backup_dir = '../data/backup/extract_'.uniqid();
					copy_recursive('../data', $backup_dir, '../data/backup');
					delete_recursive('../data', false, '../data/backup');
					if ($a->extract('../data') == true) {
						delete_recursive('../data/backup/');
						echo '<p>'.locale('desc_unzip-ready',true).'</p>';
						$version_installed = file_get_contents('../data/version.txt');
						$version_available = file_get_contents('./update/version.txt');
						if ($version_installed != $version_available) {
							echo '<p>'.locale('desc_update-needed',true).'</p>';
							echo '<p><a class="nonewtab" href="update/index.php?nolink=true&'.SID.csrf_protection_get_html_ret().'">'.locale('link_next',true).'</a></p>';						
						} else {
							echo '<p><a class="nonewtab" href="backup_unzip.php?'.SID.csrf_protection_get_html_ret().'">'.locale('link_back',true).'</a></p>';
						}
					} else {
						copy_recursive($backup_dir, '../data');
						delete_recursive('../data/backup/');
						echo '<p>'.locale('desc_unknown-format',true).'</p>';
						unlink('../data/backup/'.$_FILES['file']['name']);						
					}
				} else {
					echo '<p>'.locale('desc_unknown-format',true).'</p>';
					unlink('../data/backup/'.$_FILES['file']['name']);
				}

			} else {
				echo '<p>'.locale('desc_copy-error',true).'</p><p><a href="backup_unzip.php?'.SID.csrf_protection_get_html_ret().'" class="nonewtab">'.locale('link_back',true).'</a></p>';
			}
			
		} else {
			echo '<p>'.locale('desc_unknown-suffix',true).'</p><p><a href="backup_unzip.php?'.SID.csrf_protection_get_html_ret().'" class="nonewtab">'.locale('link_back',true).'</a></p>';
		}

	} else {
		echo '<p>'.locale('desc_no-file',true).'</p><p><a href="backup_unzip.php?'.SID.csrf_protection_get_html_ret().'" class="nonewtab">'.locale('link_back',true).'</a></p>';
	}

} else {
?>
		<h1><?php locale('title_backup-unzip') ?></h1>
		<p>
			<?php locale('desc_select-file') ?>
		</p>
		<p>
			<form action="backup_unzip.php?<?php echo SID; csrf_protection_get_html() ?>" method="post" enctype="multipart/form-data" name="upload">
			<input type="file" name="file"><br>
			<input type="submit" name="submit" value="<?php locale('button_upload-install') ?>">
			</form>
		</p>
		<p>
			<i>
				<?php locale('desc_overwritten-data') ?>
			</i>
		</p>
		<p>
			<i>
				<?php locale('desc_install-alternative') ?>
			</i>
		</p>
		<p>
			<a class="nonewtab" href="backup.php?<?php echo SID; csrf_protection_get_html() ?>"><?php locale('link_back') ?></a>
		</p>
<?php
}
?>

	</body>
</html>
