<?php
/*  cms-db  Copyright (C) 2007-2010 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */

define('cms-db', 'backend');

include('checkuser.inc.php');
checkuser('blog');
include('locale.inc.php');
$locale = new LocalizingClass('blog');

if (isset($_POST['button_save'])) {
	include('escape.inc.php');
	$id = $_POST['id'];
	$title = $_POST['title'];
	$tags = $_POST['tags'];
	$text = $_POST['content'];
	$text = escapeSL($text);
	$autosave = '../data/blog/.autosave/'.$id;
	if (substr($id, 0, 3) !== 'new') {
		$filename = '../data/blog/articles/'.$id.'/content';
		$data = file_get_contents($filename);
		$data = explode("\n", $data, 5);
		$author = $data[1];
		$time = $data[2];
		$oldtags = $data[3];
	} else {
		$articles = array();
		if ($handle = opendir('../data/blog/articles')) {
			while (false !== ($file = readdir($handle))) {
				if ($file != '.' && $file != '..') {
					$articles[] = $file;
				}
			}
			closedir($handle);
		}
		natsort($articles);
		$articles = array_reverse($articles);
		$lastentry = $articles[0];
		$id = intval($lastentry) + 1;
		$filename = '../data/blog/articles/'.$id.'/content';
		include('../data/users/'.$_SESSION['CMS-User']);
		$author = $_SESSION['CMS-User'].'-'.$user;
		$time = time();
		$oldtags = '';
		mkdir('../data/blog/articles/'.$id);
	}
	include('mobile.inc.php');
	if (!supportscontenteditable()) {
		include('mobilemarkup.inc.php');
		$text = get_xhtml_from_mm($text);
	}
	if (is_writable($filename) || !file_exists('../data/blog/articles/'.$id.'/content')) {
		file_put_contents($filename, $title."\n".$author."\n".$time."\n".$tags."\n".$text);
		$oldtags = explode(' ', $oldtags);
		$newtags = explode(' ', $tags);
		$removedtags = array_diff($oldtags, $newtags);
		foreach ($removedtags as $tag) {
			if (file_exists('../data/blog/tags/'.$tag) && is_file('../data/blog/tags/'.$tag)) {
				$oldarticles = file_get_contents('../data/blog/tags/'.$tag);
				$oldarticles = explode("\n", $oldarticles);
				$articles = array();
				foreach($oldarticles as $article) {
					if ($article != $id) {
						$articles[] = $article;
					}
				}
				if (count($articles) != 0) {
					natsort($articles);
					$articles = implode("\n", $articles);
					file_put_contents('../data/blog/tags/'.$tag, $articles);
				} else {
					unlink('../data/blog/tags/'.$tag);
				}
			}
		}
		$addedtags = array_diff($newtags, $oldtags);
		foreach ($addedtags as $tag) {
			if (!is_dir('../data/blog/tags/'.$tag)) {
				if (file_exists('../data/blog/tags/'.$tag)) {
					$articles = file_get_contents('../data/blog/tags/'.$tag);
					$articles = explode("\n", $articles);
					$articles[] = $id;
					natsort($articles);
				} else {
					$articles = array($id);
				}
				$articles = implode("\n", $articles);
				file_put_contents('../data/blog/tags/'.$tag, $articles);
			}
		}
		if (file_exists($autosave)) unlink($autosave);
		include('cache.inc.php');
		clear_cache('blog');
		header('Location:blog.php?saved='.$id.'&'.SID.csrf_protection_get());
	} else {
		include('error.inc.php');
		throw_error(sprintf(locale('desc_error-fileperms',true), $filename), 'blogentry.php?id='.$filename.'&'.SID.csrf_protection_get());
	}
} elseif (isset($_GET['action_edit'])) {
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title><?php locale('title_edit-blogentry') ?></title>
		<meta http-equiv="content-type" content="text/html; charset=utf-8" />
		<link rel="stylesheet" type="text/css" href="style.css" />
		<style type="text/css">
		<!--
		input.date {
			text-align: center;
		}
		-->
		</style>
		<script type="text/javascript" src="jquery.js"></script>
		<script type="text/javascript">
		<!--
		function updateTags() {
			tags = new Array();
			$("#tageditor span.tag span.content")
				.each(function() {
					tags.push($(this).text());
				});
			var tags = tags.join(" ");
			$("#tags").val(tags);
		}
		$(function () {
			$("input.date").focus(function () {
				window.setTimeout($(this).select(), 100);
			});
			$("#tags").hide();
			$("label[for=tags]").after("<span id='tageditor'></span>");
			if ($("#tags").val() != "") {
				var tags = $("#tags").val().split(" ");
				$.each(tags, function(key, tag) {
					$("#tageditor")
						.append(" <span class='tag'><span class='content'>"+tag+"</span><a href='#' class='remove' title=\"<?php locale_escape('link_remove', '"'); ?>\">X</a></span>")
						.find("a.remove")
						.click(function() {
							$(this).parent().remove();
							updateTags();
						});
					
				});
			}
			$("#tageditor")
				.append(" <a href='#' class='addtag'><?php locale_escape('link_add', '"') ?></a>")
				.find("a.addtag")
				.click(function() {
					var newtag = prompt("<?php locale_escape('desc_add', '"') ?>", "");
					if (newtag != null) {
						newtag = newtag.replace(/[^a-zA-Z 0-9]+/g,'');
						newtag = newtag.replace(/\s+/g, '-');
						newtag = newtag.toLowerCase();
						$(this)
							.before("<span class='tag'><span class='content'>"+newtag+"</span><a href='#' class='remove' title=\"<?php locale_escape('link_remove', '"'); ?>\">X</a></span> ")
							.prev()
							.find("a.remove")
							.click(function() {
								$(this).parent().remove();
								updateTags();
							});
						updateTags();
					}
				});
			//$("#formbuttons input[type=submit]").focus(updateTags);
			//$("#tagshowto").remove();
		});
		//-->
		</script>
		<?php
		include('../functions_url.inc.php');
		include('wymeditor.inc.php');
		include('keep-session-alive.inc.php');
		?>
		<script type="text/javascript">
		<!--
		var defaultautosafeinterval = 30; // defines the interval for doing an autosave in seconds

		function saved(ret) {
			$("#autosave").text('<?php locale_escape('desc_autosave-saved', "'") ?>');
			autosavecount = defaultautosafeinterval;
			autosaveinterval = window.setInterval("autosave()", 1000);
		}
		function save() {
			window.clearInterval(autosaveinterval);
			var content = getTextareaContent('#content');
			var title = $("input#title").val();
			updateTags();
			var tags = $("input#tags").val();
			if (oldcontent != content || oldtitle != title || oldtags != tags) {
				oldcontent = content;
				oldtitle = title;
				oldtags = tags;
				$("#autosave").text('<?php locale_escape('desc_autosave-saving', "'") ?>');
				var request = initAjax();
				doPOSTRequest(request, 'saved', 'autosaveblog.php?<?php echo SID.csrf_protection_get() ?>', 'id=<?php echo $_GET['id'] ?>&content='+encodeURIComponent(content)+'&title='+encodeURIComponent(title)+'&tags='+encodeURIComponent(tags));
			} else {
				$("#autosave").text('<?php locale_escape('desc_autosave-skipped', "'") ?>');
				autosavecount = defaultautosafeinterval;
				autosaveinterval = window.setInterval("autosave()", 1000);
			}
		}
		function autosave() {
			autosavecount = autosavecount - 1;
			$("#autosave").text('<?php printf(locale_escape('desc_autosave-next', "'", true), '\'+autosavecount+\'') ?>');
			if (autosavecount == 0) {
				save();
			}
		}
		$(window).load(function () {
			$("#save").html('<input type="button" id="autosavebutton" name="button" value="<?php locale_escape('button_savedraft', "'") ?>" disabled="disabled" />').find("input").click(save);
			// Timeout as work-around for Opera: wait for WYMeditor to load
			waitint = window.setInterval(function () { $("#autosave").append('.'); }, 1000);
			window.setTimeout(function () {
				oldcontent = getTextareaContent('#content');
				oldtitle = $("input#title").val();
				updateTags();
				oldtags = $("input#tags").val();
				autosavecount = defaultautosafeinterval;
				autosaveinterval = window.setInterval("autosave()", 1000);
				$("#autosavebutton").removeAttr("disabled");
				window.clearInterval(waitint);
			}, 5000);
		});
		//-->
		</script>
	</head>
	<body>

		<h1><?php locale('title_edit-blogentry') ?></h1>

		<noscript><p class="hint"><?php locale('desc_javascript') ?></p></noscript>

		<?php
		$article = $_GET['id'];
		if (file_exists('../data/blog/.autosave/'.$article)) {
			if (!isset($_GET['discard'])) {
				if (substr($article, 0, 3) === 'new') {
					$linktext = locale('link_delete-draft',true);
				} else {
					$linktext = locale('link_discard-changes',true);
				}
				echo '<p class="hint">'.locale('desc_autosave-blog',true).' <a href="blogentry.php?id='.$article.'&action_edit=a&discard=true&'.SID.csrf_protection_get_html_ret().'" class="nonewtab">'.$linktext.'</a></p>';
				$filename = '../data/blog/.autosave/'.$article;
				$data = file_get_contents($filename);
				$data = explode("\n", $data, 3);
				$title = $data[0];
				$tags = $data[1];
				$text = $data[2];
			} else {
				unlink('../data/blog/.autosave/'.$article);
			}
		}
		if (!file_exists('../data/blog/.autosave/'.$article)) {
			if (file_exists('../data/blog/articles/'.$article.'/content')) {
				$filename = '../data/blog/articles/'.$article.'/content';
				$data = file_get_contents($filename);
				$data = explode("\n", $data, 5);
				$title = $data[0];
				//$author = $data[1];
				//$time = $data[2];
				$tags = $data[3];
				$text = $data[4];
			} else {
				$title = '';
				$tags = '';
				$text = '';
			}
		}
		?>

		<p>
			<form action="blogentry.php?<?php echo SID; csrf_protection_get_html() ?>" method="post">
				<input type="hidden" name="id" value="<?php echo $article ?>" />
				<label for="title"><?php locale('label_title') ?></label>
				<input type="text" name="title" id="title" value="<?php echo htmlspecialchars($title) ?>" size="30" /><br />
				<label for="tags"><?php locale('label_tags') ?></label>
				<input type="text" name="tags" id="tags" value="<?php echo htmlspecialchars($tags) ?>" size="30" /><br />
				<span id="tagshowto"><?php locale('desc_tags-howto') ?><br /></span>
				<!--<label><?php locale('label_date') ?></label>
				<input class="date" type="text" name="date_y" value="" size="4" maxlength="4" />-<input class="date" type="text" name="date_m" value="" size="2" maxlength="2" />-<input class="date" type="text" name="date_d" value="" size="2" maxlength="2" />
				<input class="date" type="text" name="time_h" value="" size="2" maxlength="2" />:<input class="date" type="text" name="time_m" value="" size="2" maxlength="2" />:<input class="date" type="text" name="time_s" value="" size="2" maxlength="2" /><br />
				<?php locale('desc_date-howto') ?><br />--><br />
				<?php
				if (!supportscontenteditable()) {
					include('mobilemarkup.inc.php');
					$content = get_mm_from_xhtml($text);
				} else {
					$content = str_replace(array('&', '<', '>'),
						array('&amp;', '&lt;', '&gt;'), $text);
				}
				?>
				<textarea class="wymeditor" id="content" name="content" cols="80" rows="20"><?php echo $content ?></textarea><br />
				<div id="formbuttons">
					<input type="submit" name="button_save" value="<?php locale('button_publish') ?>" class="wymupdate" />
					<span id="save">&nbsp;</span>
					<span id="autosave" style="color: #555">&nbsp;</span>
				</div>
			</form>
		</p>

		<h2><?php locale('link_comments') ?></h2>

		<?php
		include('guestbook.inc.php');
		?>

	</body>
</html>
<?php
} elseif (isset($_POST['button_delete'])) {
	$id = $_POST['id'];
	$folder = '../data/blog/articles/'.$id;
	$filename_content = $folder.'/content';
	$filename_comments = $folder.'/comments';
	$filename_autosave = '../data/blog/.autosave/'.$id;

	if (file_exists($filename_content)) {
		/*
		 * remove the tags
		 */
		$data = file_get_contents($filename_content);
		$data = explode("\n", $data, 5);
		$tags = explode(' ', $data[3]);
		foreach ($tags as $tag) {
			if (file_exists('../data/blog/tags/'.$tag) && is_file('../data/blog/tags/'.$tag)) {
				$oldarticles = file_get_contents('../data/blog/tags/'.$tag);
				$oldarticles = explode("\n", $oldarticles);
				$articles = array();
				foreach($oldarticles as $article) {
					if ($article != $id) {
						$articles[] = $article;
					}
				}
				if (count($articles) != 0) {
					natsort($articles);
					$articles = implode("\n", $articles);
					file_put_contents('../data/blog/tags/'.$tag, $articles);
				} else {
					unlink('../data/blog/tags/'.$tag);
				}
			}
		}

		/* delete files */
		unlink($filename_content);
		if (file_exists($filename_comments)) {
			unlink($filename_comments);
		}
		rmdir($folder);
		include('cache.inc.php');
		clear_cache('blog');
	}
	if (file_exists($filename_autosave)) {
		unlink($filename_autosave);
	}
	header('Location:blog.php?deleted=a&'.SID.csrf_protection_get());
} elseif (isset($_GET['action_delete'])) {
	$id = $_GET['id'];
	if (file_exists('../data/blog/articles/'.$id.'/content')) {
		$filename = '../data/blog/articles/'.$id.'/content';
		$data = file_get_contents($filename);
		$data = explode("\n", $data, 5);
		$title = $data[0];
		$type = 'blogentry';
	} elseif (file_exists('../data/blog/.autosave/'.$id)) {
		$filename = '../data/blog/.autosave/'.$id;
		$data = file_get_contents($filename);
		$data = explode("\n", $data, 3);
		$title = $data[0];
		$type = 'draft';
	} else {
		die();
	}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title><?php locale('title_delete-blogentry') ?></title>
		<meta http-equiv="content-type" content="text/html; charset=utf-8" />
		<link rel="stylesheet" type="text/css" href="style.css">
	</head>
	<body>

	<h1><?php locale('title_delete-blogentry') ?></h1>

	<p>
		<?php printf(locale('desc_delete-'.$type,true), htmlspecialchars($title)) ?>
		<form action="blogentry.php?<?php echo SID; csrf_protection_get_html() ?>" method="post">
			<input type="hidden" name="id" value="<?php echo $id ?>" />
			<input type="submit" name="button_delete" value="<?php locale('button_yes') ?>" />
			<a href="blog.php?<?php echo SID; csrf_protection_get_html() ?>" class="nonewtab"><?php locale('button_no') ?></a>
		</form>
	</p>

	</body>
</html>
<?php
}
?>
