<?php
/*  cms-db  Copyright (C) 2007-2010 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */

if (!defined('cms-db')) {
	include('friendlyerror.firewall.inc.php');
	die();
}

// very ugly hack for PHP 5.3
$default_timezone = @date_default_timezone_get();
date_default_timezone_set($default_timezone);

// ensure utf-8 encoding
header('Content-Type: text/html; charset=utf-8');

session_start();

require_once('csrfprotection.inc.php');

function checkuser($section) {
	if ($_SESSION['CMS-Login'] != 'LOGEDIN') {
		header('Location:index.php');
		die();
	}
	if (!checkuser2($section)) {
		checkuser_quit($section);
	}
	check_csrf_protection();
}
function checkuser2($section) {
	if (!user_has_rights($_SESSION['CMS-User'], $section)) {
		if ($_SESSION['CMS-SU'] == 'NONE' or !user_has_rights($_SESSION['CMS-SU'], $section)) {
			return false;
		}
	}
	return true;
}
function user_has_rights($userfile, $section) {
	if ($userfile == 'root.php') {
		return true;
	}
	if ($userfile != 'firstrun') {
		include('../data/users/'.$userfile);
	}
	switch ($section) {
		case 'pages':
			if ($user_pages != 'on') { return false; }
			break;
		case 'files':
			if ($user_files != 'on') { return false; }
			break;
		case 'includes':
			if ($user_includes != 'on') { return false; }
			break;
		case 'template':
			if ($user_template != 'on') { return false; }
			break;
		case 'gbook':
			if ($user_gbook != 'on') { return false; }
			break;
		case 'blog':
			if ($user_blog != 'on') { return false; }
			break;
		case 'stats':
			if ($user_stats != 'on') { return false; }
			break;
		case 'settings':
			if ($_SESSION['CMS-Settings'] != 'forced') {
				header('Location:changepw.php?'.SID.csrf_protection_get());
			} else {
				return false;
			}
			break;
		case 'root':
			return false;
		case 'firstrun':
			if ($userfile != 'firstrun') { return false; }
			break;
	}
	return true; 
}
function checkuser_quit($section) {
	include('sudo-gui.inc.php');
	sudo_gui($section);
	die();
}
?>
