<?php
/*  cms-db  Copyright (C) 2007-2010 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */

define('cms-db', 'backend');

include('checkuser.inc.php');
checkuser('root');
include('locale.inc.php');
$locale = new LocalizingClass('edituser');

$message = '';
include('escape.inc.php');
if (isset($_POST['button']) && strpos($_POST['file'], '/') === false) {
	$file = $_POST['file'];
	$error = false;
	if ($_POST['password'] == 'on') {
		if ($_POST['pass'] == $_POST['repeat']) {
			$pass = sha1($file.escapeSL($_POST['pass']));
		} else {
			$message = '<p class="error">'.locale('desc_error-invalid-data',true).'</p>';
			$error = true;
		}
	} else {
		include('../data/users/'.$file);
	}
	if (!$error) {
		$writethis = '<?php
		$user = \''.escapeForm($_POST['user']).'\';
		$pass = \''.escapeSave($pass).'\';
		$user_pages = \''.escapeForm($_POST['pages']).'\';
		$user_files = \''.escapeForm($_POST['files']).'\';
		$user_includes = \''.escapeForm($_POST['includes']).'\';
		$user_template = \''.escapeForm($_POST['template']).'\';
		$user_gbook = \''.escapeForm($_POST['gbook']).'\';
		$user_blog = \''.escapeForm($_POST['blog']).'\';
		$user_stats = \''.escapeForm($_POST['stats']).'\';
		?>';
		file_put_contents('../data/users/'.$file, $writethis);
		header('Location: users.php?saved='.$_POST['user'].'&'.SID.csrf_protection_get());
	}
} elseif (strpos($_GET['user'], '/') === false) {
	$file = $_GET['user'];
} else {
	die();
}
include('../data/users/'.$file);
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title><?php locale('title_edituser') ?></title>
		<meta http-equiv="content-type" content="text/html; charset=utf-8" />
		<link rel="stylesheet" type="text/css" href="style.css" />
		<link rel="stylesheet" type="text/css" href="<?php include('mobile.inc.php'); echo mobile() ? 'style-extra-mobile.css' : 'style-extra.css'; ?>" />
	</head>
	<body>

		<h1><?php locale('desc_settings') ?></h1>

		<div class="anchormenu"><span class="leftcorner">&nbsp;</span><ul><li><a href="users.php?<?php echo SID; csrf_protection_get_html() ?>" class="nonewtab active"><?php locale('link_usersettings') ?></a></li><li><a href="commonsettings.php?<?php echo SID; csrf_protection_get_html() ?>" class="nonewtab"><?php locale('link_commonsettings') ?></a></li><li><a href="url.php?<?php echo SID; csrf_protection_get_html() ?>" class="nonewtab"><?php locale('link_urlsettings') ?></a></li><li><a href="ftpsettings.php?<?php echo SID; csrf_protection_get_html() ?>" class="nonewtab"><?php locale('link_ftpsettings') ?></a></li><li><a href="adminsettings.php?<?php echo SID; csrf_protection_get_html() ?>" class="nonewtab"><?php locale('link_adminsettings') ?></a></li><li><a href="locale.php?<?php echo SID; csrf_protection_get_html() ?>" class="nonewtab"><?php locale('link_localesettings') ?></a></li></ul><span class="rightcorner">&nbsp;</span></div>

		<?php echo $message ?>

		<h2><?php locale('title_edituser') ?></h2>
		<p>
			<form action="edituser.php?<?php echo SID; csrf_protection_get_html() ?>" method="post">
				<input type="hidden" name="file" value="<?php echo $file ?>" />
				<?php locale('label_username') ?>: <input type="text" name="user" value="<?php echo htmlspecialchars($user) ?>" /><br />
				<input type="checkbox" name="password" id="password" />
				<label for="password"><?php locale('label_change-password') ?></label><br />
				<?php locale('label_password') ?>: <input type="password" name="pass" value="" /><br />
				<?php locale('desc_repeat') ?> <input type="password" name="repeat" value="" /><br />
				<input type="checkbox" name="pages" id="pages" <?php if ($user_pages == 'on') { echo 'checked="checked"'; }?> />
				<label for="pages"><?php locale('label_user-pages') ?></label><br />
				<input type="checkbox" name="files" id="files" <?php if ($user_files == 'on') { echo 'checked="checked"'; }?> />
				<label for="files"><?php locale('label_user-files') ?></label><br />
				<input type="checkbox" name="includes" id="includes" <?php if ($user_includes == 'on') { echo 'checked="checked"'; }?> />
				<label for="includes"><?php locale('label_user-includes') ?></label><br />
				<input type="checkbox" name="template" id="template" <?php if ($user_template == 'on') { echo 'checked="checked"'; }?> />
				<label for="template"><?php locale('label_user-template') ?></label><br />
				<input type="checkbox" name="gbook" id="gbook" <?php if ($user_gbook == 'on') { echo 'checked="checked"'; }?> />
				<label for="gbook"><?php locale('label_user-gbook') ?></label><br />
				<input type="checkbox" name="blog" id="blog" <?php if ($user_blog == 'on') { echo 'checked="checked"'; }?> />
				<label for="blog"><?php locale('label_user-blog') ?></label><br />
				<input type="checkbox" name="stats" id="stats" <?php if ($user_stats == 'on') { echo 'checked="checked"'; }?> />
				<label for="stats"><?php locale('label_user-stats') ?></label><br /><br />
				<i><?php locale('desc_users') ?></i><br /><br />
				<input type="submit" name="button" value="<?php locale('button_save') ?>">
				<a href="users.php?<?php echo SID; csrf_protection_get_html() ?>" class="nonewtab"><?php locale('button_cancel') ?></a>
			</form>
		</p>

	</body>
</html>
