<?php
/*  cms-db  Copyright (C) 2007-2010 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */

define('cms-db', 'backend');

include('checkuser.inc.php');
checkuser('includes');
include('locale.inc.php');
$locale = new LocalizingClass('includes');
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title><?php locale('desc_includes') ?></title>
		<meta http-equiv="content-type" content="text/html; charset=utf-8" />
		<link rel="stylesheet" type="text/css" href="style.css">
		<link rel="stylesheet" type="text/css" href="<?php include('mobile.inc.php'); echo mobile() ? 'style-extra-mobile.css' : 'style-extra.css'; ?>" />
		<script src="jquery.js" type="text/javascript"></script>
		<script src="anchormenu.js" type="text/javascript"></script>
		<?php if (mobile()) { ?>
		<script type="text/javascript">
		<!--
		$(function () {
			$("table").css("width", "100%")
			$(".list_info").css("display", "none");
			$(".list_name").each(function () {
				$(this).wrapInner('<a href="#" style="display: block; padding: .5em;"></a>');
				$(this).click(function () {
					$(".info").remove();
					$(this).find("a").after('<span class="info" style="display: block; padding: .5em"></span>');
					var text = $(this).parent().find(".list_info").html()
					$(this).find(".info").append('<span style="display:block">' + text + '</span>');
				});
			});
		});
		//-->
		</script>
		<?php } ?>
	</head>
	<body>

		<h1><?php locale('desc_includes') ?></h1>

		<div class="anchormenu"><span class="leftcorner">&nbsp;</span><ul><li><a href="#inclist" class="nonewtab"><?php locale('link_inclist') ?></a></li><li><a href="#create" class="nonewtab"><?php locale('button_create') ?></a></li></ul><span class="rightcorner">&nbsp;</span></div>

		<?php
		if (isset($_GET['special'])) {
			if ($_GET['special'] == 'deleteinc') {
				echo '<p class="hint">'.locale('desc_moved-to-recyclebin',true).'</p>';
			} elseif ($_GET['special'] == 'restoreinc') {
				echo '<p class="hint">'.locale('desc_restored',true).'</p>';
			}
		}
		?>

		<div id="inclist">
			<h2><?php locale('title_inclist') ?></h2>
			<table>
				<tr>
					<th><?php locale('desc_name') ?></th>
					<th class="list_info"><?php locale('desc_action') ?></th>
				</tr>
				<?php
				$vorhanden = false;
				$files = array();
				if ($handle = opendir('../data/includes')) {
				while (false !== ($file = readdir($handle))) {
					if($file != "." && $file != "..") {
						$vorhanden = true;
						$files[] = $file;
					}
				}
				closedir($handle);
				}
				?>
				<?php
				if ($vorhanden) {
					natcasesort($files);
					$color = 0;
					foreach ($files as $file) {
						if ($color == 0) {
							$class = ' class="bright"';
							$color = 1;
						} else {
							$class = ' class="dark"';
							$color = 0;
						}
						echo '<tr'.$class.'>
							<td class="list_name">'.$file.'</td>
							<td class="list_info">
								<a href="editinc.php?inc='.$file.'&'.SID.csrf_protection_get_html_ret().'"><img src="icons/edit.png" style="vertical-align:middle" border="0" height="16" width="16" />'.locale('link_edit',true).'</a>
								<a href="renameinc.php?inc='.$file.'&'.SID.csrf_protection_get_html_ret().'"><img src="icons/rename.png" style="vertical-align:middle" border="0" height="16" width="16" />'.locale('link_rename',true).'</a>
								<a href="delinc.php?inc='.$file.'&'.SID.csrf_protection_get_html_ret().'"><img src="icons/delete.png" style="vertical-align:middle" border="0" height="16" width="16" />'.locale('link_delete',true).'</a>
							</td>
						</tr>';
					}
				} else {
					echo '<tr><td colspan="2">'.locale('desc_no-includes',true).'</td></tr>';
				}
				?>
			</table>
			<p>
				<i>
					<?php locale('desc_recyclebin') ?>
				</i>
			</p>
		</div>

		<div id="create">
			<h2><?php locale('title_new') ?></h2>
			<p>
				<?php locale('desc_new') ?>
			</p>
			<p>
				<form action="newinc.php?<?php echo SID; csrf_protection_get_html() ?>" target="_self" method="post">
					<input type="text" name="name" value="" size="10" maxlength="99">
					<input type="submit" name="button" value="<?php locale('button_create') ?>">
				</form>
			</p>
		</div>

</body>
</html>
