<?php
/*  cms-db  Copyright (C) 2007-2010 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */

if (!defined('cms-db')) {
	include('friendlyerror.firewall.inc.php');
	die();
}

class LocalizingClass {

	protected $filename;
	protected $count = 0;
	protected $time_start;
	public $langcode;
	public $locale = array();

	//function __construct( $filename, $langcode = $_SESSION['CMS-Locale'], $path_before = './' ) {
	function __construct( $filename, $langcode = 'SESSION', $path_before = './' ) {
		$time_start = microtime(true);
		//echo '<!--Intializing LocalizingClass...-->';
		if ($langcode == 'SESSION') {
			$langcode = $_SESSION['CMS-Locale'];
			//echo '<!--LocalizingClass: loading language code from $_SESSION-->';
		}
		if (!file_exists($path_before.'locales/'.$langcode.'/locale_'.$filename.'.php')) {
			$fe_title = 'cms -db LocalizingClass';
			$fe_subtitle = 'LocalizingClass Error';
			$fe_content = '	<p>Unable to find the locale file.</p>
							<p>A reason for this could be that your locale set doesn\'t contain translations for this file.</p>
							<h3>Useful Information for debugging:</h3>
							<p>
								<i>File:</i> '.$path_before.'locales/'.htmlspecialchars($langcode).'/locale_'.$filename.'.php<br />
								<i>Path before:</i> '.$path_before.'<br />
								<i>Language code:</i> '.htmlspecialchars($langcode).'<br />
								<i>File name:</i> '.$filename.'
							</p>';
			include('friendlyerror.inc.php');
		}
		include( $path_before.'locales/'.$langcode.'/common.php' );
		include( $path_before.'locales/'.$langcode.'/locale_'.$filename.'.php' );
		$this->filename = $filename;
		$this->locale = $locale;
		$this->time_start = $time_start;
		$this->langcode = $langcode;
		//echo '<!--Intialized LocalizingClass.-->';
	}
	
	function __destruct() {
		$time_now = microtime(true);
		$time = $time_now - $this->time_start;
		# We would display the report, but Internet Explorer falls back
		# to quirks mode on the website because this is displayed before
		# the doctype there.
		/*echo '<!-- cms -db LocalizingClass report
Replaced strings: '.$this->count.'
Runtime (in s): '.$time.' -->';*/
		//echo '<!--LocalizingClass was killed.-->';
	}

	public function getLocalizedText( $which ) {
		if ( isset( $this->locale[$this->filename][$which] ) ) {
			$text = $this->locale[$this->filename][$which];
		} else if ( isset( $this->locale['common'][$which] ) ) {
			$text = $this->locale['common'][$which];
		} else {
			$text = 'Localized text not found: '.$which;
		}
		$this->count++;
		return $text;
	}

	public function printLocalizedText( $which ) {
		echo $this->getLocalizedText( $which );
	}

}

/* helper function for getting localized text */
function locale($text, $return = false, $locale = false) {
	if ($locale == false) {
		global $locale;
	}
	if ($return != true) {
		$locale->printLocalizedText($text);
		return true;
	} else {
		return $locale->getLocalizedText($text);
	}
}

function locale_escape($text, $char, $return = false, $locale = false) {
	if ($locale == false) {
		global $locale;
	}
	$string = $locale->getLocalizedText($text);
	$string = str_replace($char, '\\'.$char, $string);
	if ($return != true) {
		echo $string;
		return true;
	} else {
		return $string;
	}
}
?>
