<?php
/*  cms-db  Copyright (C) 2007-2010 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */

if (!defined('cms-db')) {
	include('friendlyerror.firewall.inc.php');
	die();
}

/* Converts cms -db mobile markup to xhtml */
function get_xhtml_from_mm($content) {
	$n = "\n";
	$content = str_replace("\r", '', $content);
	$content = '<p>'.$content.'</p>';
	$content = str_replace($n.$n, '</p><p>', $content);
	function parseUnsortedList($m) {
		$text = '<ul><li>'.$m[1].'</li></ul>';
		$text = str_replace("\n".'* ', '</li><li>', $text);
		$text = str_replace("\n".' * ', '</li><li>', $text);
		$text = str_replace('<li></li>', '', $text);
		return $text;
	}
	function parseSortedList($m) {
		$text = '<ol><li>'.$m[1].'</li></ol>';
		$text = str_replace("\n".'* ', '</li><li>', $text);
		$text = str_replace("\n".' * ', '</li><li>', $text);
		$text = str_replace('<li></li>', '', $text);
		return $text;
	}
	$content = preg_replace_callback('/<ul>(.*)'.$n.'<\/ul>/sU', 'parseUnsortedList', $content);
	$content = preg_replace_callback('/<ol>(.*)'.$n.'<\/ol>/sU', 'parseSortedList', $content);
	$content = preg_replace('/<p>====== (.*) ====== \((.*)\)<\/p>/U', '<h6 id="$2">$1</h6>', $content);
	$content = preg_replace('/<p>===== (.*) ===== \((.*)\)<\/p>/U', '<h5 id="$2">$1</h5>', $content);
	$content = preg_replace('/<p>==== (.*) ==== \((.*)\)<\/p>/U', '<h4 id="$2">$1</h4>', $content);
	$content = preg_replace('/<p>=== (.*) === \((.*)\)<\/p>/U', '<h3 id="$2">$1</h3>', $content);
	$content = preg_replace('/<p>== (.*) == \((.*)\)<\/p>/U', '<h2 id="$2">$1</h2>', $content);
	$content = preg_replace('/<p>= (.*) = \((.*)\)<\/p>/U', '<h1 id="$2">$1</h1>', $content);
	$content = preg_replace('/<p>====== (.*) ======<\/p>/U', '<h6>$1</h6>', $content);
	$content = preg_replace('/<p>===== (.*) =====<\/p>/U', '<h5>$1</h5>', $content);
	$content = preg_replace('/<p>==== (.*) ====<\/p>/U', '<h4>$1</h4>', $content);
	$content = preg_replace('/<p>=== (.*) ===<\/p>/U', '<h3>$1</h3>', $content);
	$content = preg_replace('/<p>== (.*) ==<\/p>/U', '<h2>$1</h2>', $content);
	$content = preg_replace('/<p>= (.*) =<\/p>/U', '<h1>$1</h1>', $content);
	$content = preg_replace('/([^:])\/\/(.*[^:])\/\//U', '$1<em>$2</em>', $content);
	$content = preg_replace('/\*\*(.*)\*\*/U', '<strong>$1</strong>', $content);
	$content = strtr($content, array(
		'<p><ul>' => '<ul>', '</ul></p>' => '</ul>',
		'<p><ol>' => '<ol>', '</ol></p>' => '</ol>',
		'<p><pre>' => '<pre>', '</pre></p>' => '</pre>',
		'<p><table>' => '<table>', '</table></p>' => '</table>'
	));
	$content = str_replace(array('\&', '\<', '\>'), array('&amp;', '&lt;', '&gt;'), $content);
	if (function_exists('tidy_repair_string')) {
		$config['output-xhtml'] = true;
		$config['show-body-only'] = true;
		$config['logical-emphasis'] = true;
		$config['wrap'] = 0;
		$config['newline'] = 'LF';
		$oldcontent = $content;
		$content = tidy_repair_string($content, $config, 'utf8');
		$content = str_replace($n, '', $content);
		if ($content == '') $content = $oldcontent;
	}
	return $content;
}

/* Gets cms -db mobile markup from xhtml */
function get_mm_from_xhtml($content) {
	$n = "\n";
	if (substr($content, 0, 3) == '<p>') $content = substr($content, 3);
	if (substr($content, strlen($content)-4, 4) == '</p>') $content = substr($content, 0, strlen($content)-4);
	$content = str_replace('</p><p>', $n.$n, $content);
	$content = str_replace('</p>', $n.$n, $content);
	$content = str_replace('<p>', $n.$n, $content);
	$content = str_replace('<ul>', '<ul>'.$n, $content);
	$content = str_replace('<ol>', '<ol>'.$n, $content);
	$content = str_replace('</ul>', '</ul>'.$n.$n, $content);
	$content = str_replace('</ol>', '</ol>'.$n.$n, $content);
	$content = preg_replace('/<li>(.*)<\/li>/U', ' * $1'.$n, $content);
	$content = preg_replace('/<h1>(.*)<\/h1>/U', '= $1 ='.$n.$n, $content);
	$content = preg_replace('/<h2>(.*)<\/h2>/U', '== $1 =='.$n.$n, $content);
	$content = preg_replace('/<h3>(.*)<\/h3>/U', '=== $1 ==='.$n.$n, $content);
	$content = preg_replace('/<h4>(.*)<\/h4>/U', '==== $1 ===='.$n.$n, $content);
	$content = preg_replace('/<h5>(.*)<\/h5>/U', '===== $1 ====='.$n.$n, $content);
	$content = preg_replace('/<h6>(.*)<\/h6>/U', '====== $1 ======'.$n.$n, $content);
	$content = preg_replace('/<h1 id="(.*)">(.*)<\/h1>/U', '= $2 = ($1)'.$n.$n, $content);
	$content = preg_replace('/<h2 id="(.*)">(.*)<\/h2>/U', '== $2 == ($1)'.$n.$n, $content);
	$content = preg_replace('/<h3 id="(.*)">(.*)<\/h3>/U', '=== $2 === ($1)'.$n.$n, $content);
	$content = preg_replace('/<h4 id="(.*)">(.*)<\/h4>/U', '==== $2 ==== ($1)'.$n.$n, $content);
	$content = preg_replace('/<h5 id="(.*)">(.*)<\/h5>/U', '===== $2 ===== ($1)'.$n.$n, $content);
	$content = preg_replace('/<h6 id="(.*)">(.*)<\/h6>/U', '====== $2 ====== ($1)'.$n.$n, $content);
	$content = preg_replace('/<em>(.*)<\/em>/U', '//$1//', $content);
	$content = preg_replace('/<strong>(.*)<\/strong>/U', '**$1**', $content);
	$content = preg_replace('/('.$n.$n.')+/', $n.$n, $content);
	$content = str_replace(array('&amp;', '&lt;', '&gt;'), array('\&', '\<', '\>'), $content);
	$content = str_replace(array('&', '<', '>'), array('&amp;', '&lt;', '&gt;'), $content);
	return $content;
}
?>
