<?php
/*  cms-db  Copyright (C) 2007-2010 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */

define('cms-db', 'backend');

include('checkuser.inc.php');
checkuser('pages');
include('locale.inc.php');
$locale = new LocalizingClass('pages');

include('../functions_url.inc.php');

if ($_GET['sec'] == 'root') {
	$ordner = '../data/pages/';
} else {
	$shorturl = get_filename_from_url($_GET['sec']);
	if ($shorturl === false) {
		die('Error: The page couldn\'t be found in the URL index.');
	}
	$ordner = '../data/pages'.substr($shorturl, 0, strrpos($shorturl, '/'));
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title><?php locale('title_sort') ?></title>
		<meta http-equiv="content-type" content="text/html; charset=utf-8" />
		<link rel="stylesheet" type="text/css" href="style.css">
		<script type="text/javascript" src="jquery.js"></script>
		<script type="text/javascript" src="jquery.ui.js"></script>
		<script type="text/javascript">
		<!--
		$(function() {
			$("#sortable").sortable({ opacity: 0.8 });
			//$("#sortable").disableSelection();
		});
		function submit() {
			location.href = "sort2.php?type=" + $("input[name=type]:checked").val() + "&sec=<?php echo $_GET['sec'] ?>&" + $("#sortable").sortable('serialize') + "&<?php echo SID; echo csrf_protection_get() ?>";
		}
		//-->
		</script>
		<style type="text/css">
		<!--
		#sortable {
			list-style-type: none;
			padding: 0;
			margin-left: 1em;
		}
		#sortable li {
			padding: 5px;
			margin: 2px;
			background: #eee;
			border: 1px solid #ccc;
			max-width: 25em;
		}
		-->
		</style>
	</head>
	<body>

		<h1><?php locale('title_sort') ?></h1>
		<noscript>
			<p><?php locale('desc_sort-nojs') ?></p>
		</noscript>
		<p>
			<input type="radio" name="type" value="manual" id="manual" checked="checked" /><label for="manual"><strong><?php locale('desc_sort-manually') ?></strong></label>
		</p>
		<ul id="sortable">
			<?php
			$exists = false;
			$files = array();
			$handle = opendir($ordner);
			while (false !== ($file = readdir($handle))) {
				if($file != '.' && $file != '..' && $file !='01,Home') {
					$files[] = $file;
				}
			}
			natsort($files);
			$i = 0;
			foreach($files as $file) {
				$show = substr($file, 3);
				$show = str_replace('_', ' ', $show);
				$show = str_replace('SLASH', '/', $show);
				$show = str_replace('AND', '&', $show);
				echo "\t\t\t";
				echo '<li id="data_'.$i.'">'.$show.'</li>';
				$exists = true;
				$i++;
			}
			closedir($handle);
			if (!$exists) {
				locale('desc_sort-no-pages');
			}
			?>
		</ul>
		<p>
			<input type="radio" name="type" value="alpha" id="alpha" /><label for="alpha"><strong><?php locale('desc_sort-alphabetically') ?></label>
		</p>
		<p>
			<?php if ($exists) { ?>
			<input type="button" value="<?php locale('button_save') ?>" onclick="submit()" />
			<?php } else { ?>
			<a href="pages.php?<?php echo SID; csrf_protection_get_html() ?>"><?php locale('link_back') ?></a>
			<?php } ?>
		</p>

	</body>
</html>
