<?php
/*  cms-db  Copyright (C) 2007-2010 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */

define('cms-db', 'backend');

include('checkuser.inc.php');
checkuser('');
include('locale.inc.php');
$locale = new LocalizingClass('space');
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title><?php locale('desc_space') ?></title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<link rel="stylesheet" type="text/css" href="style.css" />
<link rel="stylesheet" type="text/css" href="progressbar.css" />
</head>
<body>

<h1><?php locale('desc_space') ?></h1>
<h2><?php locale('title_harddisk') ?></h2>
<?php
$free = disk_free_space("../");
$total = disk_total_space("../");
$used = $total - $free;
function formatSize($size, $i = 2) {
	if($size >= 1099511627776) {
		return round($size/1099511627776, $i).' TiB';
	} elseif($size >= 1073741824) {
		return round($size/1073741824, $i).' GiB';
	} elseif($size >= 1048576) {
		return round($size/1048576, $i).' MiB';
	} elseif($size >= 1024) {
		return round($size/1024, $i).' KiB';
	} else {
		return $size.' Bytes';
	}
}
include('progressbar.inc.php');
echo '<p style="line-height: 2.25em">';
printProgressBar(25, 'em', '#2784f5', '#ccc', $used/$total);
echo '</p>';
/*$width = $used/$total*600;
echo '<div style="width: 600px; height: 30px; border: 1px solid #aaa; background: #eee">
	<div style="background: #555; height: 30px; width: '.$width.'px"></div>
</div>';*/
echo '<p>'.locale('desc_total',true).' '.formatSize($total).'<br />
'.locale('desc_used',true).' '.formatSize($used).'<br />
'.locale('desc_free',true).' '.formatSize($free).'</p>';


function count_pages($folder = '../data/pages') {
	$count_pages = 0;
	$size_pages = 0;
	if ($handle = opendir($folder)) {
		while (false !== ($file = readdir($handle))) {
			if($file != '.' && $file != '..') {
				if (is_file($folder.'/'.$file) && $file == '01,Home') {
					$count_pages++;
				}
				$size_pages += filesize($folder.'/'.$file);
				if (is_dir($folder.'/'.$file)) {
					$ret = count_pages($folder.'/'.$file);
					$count_pages += $ret[0];
					$size_pages += $ret[1];
				}
			}
		}
		closedir($handle);
	}
	return array($count_pages, $size_pages);
}
list($count_pages, $size_pages) = count_pages();

function count_files($folder = '../data/files') {
	$count_files = 0;
	$size_files = 0;
	if ($handle = opendir($folder)) {
		while (false !== ($file = readdir($handle))) {
			if($file != '.' && $file != '..') {
				if (is_file($folder.'/'.$file) && $file != '.htaccess') {
					$count_files++;
				}
				$size_files += filesize($folder.'/'.$file);
				if (is_dir($folder.'/'.$file)) {
					$ret = count_files($folder.'/'.$file);
					$count_files += $ret[0];
					$size_files += $ret[1];
				}
			}
		}
		closedir($handle);
	}
	return array($count_files, $size_files);
}
list($count_files, $size_files) = count_files();

function count_includes($folder = '../data/includes') {
	$count_includes = 0;
	$size_includes = 0;
	if ($handle = opendir($folder)) {
		while (false !== ($file = readdir($handle))) {
			if($file != '.' && $file != '..') {
				if (is_file($folder.'/'.$file)) {
					$count_includes++;
				}
				$size_includes += filesize($folder.'/'.$file);
				if (is_dir($folder.'/'.$file)) {
					$ret = count_includes($folder.'/'.$file);
					$count_includes += $ret[0];
					$size_includes += $ret[1];
				}
			}
		}
		closedir($handle);
	}
	return array($count_includes, $size_includes);
}
list($count_includes, $size_includes) = count_includes();

function count_blog($folder = '../data/blog') {
	$count_blog = 0;
	$size_blog = 0;
	if ($handle = opendir($folder)) {
		while (false !== ($file = readdir($handle))) {
			if($file != '.' && $file != '..') {
				if (is_file($folder.'/'.$file) && $file == 'content') {
					$count_blog++;
				}
				$size_blog += filesize($folder.'/'.$file);
				if (is_dir($folder.'/'.$file)) {
					$ret = count_blog($folder.'/'.$file);
					$count_blog += $ret[0];
					$size_blog += $ret[1];
				}
			}
		}
		closedir($handle);
	}
	return array($count_blog, $size_blog);
}
list($count_blog, $size_blog) = count_blog();

function count_total($folder = '../data') {
	$size_total = 0;
	if ($handle = opendir($folder)) {
		while (false !== ($file = readdir($handle))) {
			if ($file != '.' && $file != '..') {
				$size_total += filesize($folder.'/'.$file);
				if (is_dir($folder.'/'.$file)) {
					$size_total += count_total($folder.'/'.$file);
				}
			}
		}
		closedir($handle);
	}
	return $size_total;
}
$size_total = count_total();

$size_other = $size_total - $size_pages - $size_files - $size_includes - $size_blog;
?>

<h2><?php locale('title_website-contents') ?></h2>
<table>
	<tr>
		<th style="text-align:left"><?php echo $count_pages.' '; echo ($count_pages = 1) ? locale('desc_area-pages',true) : locale('desc_area-page',true) ?></th>
		<td style="text-align:right"><?php echo formatSize($size_pages) ?></td>
	</tr>
	<tr>
		<th style="text-align:left"><?php echo $count_files.' '; echo ($count_files != 1) ? locale('desc_area-files',true) : locale('desc_area-file',true) ?></th>
		<td style="text-align:right"><?php echo formatSize($size_files) ?></td>
	</tr>
	<tr>
		<th style="text-align:left"><?php echo $count_includes.' '; echo ($count_includes != 1) ? locale('desc_area-includes',true) : locale('desc_area-include',true) ?></th>
		<td style="text-align:right"><?php echo formatSize($size_includes) ?></td>
	</tr>
	<tr>
		<th style="text-align:left"><?php echo $count_blog.' '; echo ($count_blog != 1) ? locale('desc_area-blogentries',true) : locale('desc_area-blogentry',true) ?></th>
		<td style="text-align:right"><?php echo formatSize($size_blog) ?></td>
	</tr>
	<tr>
		<th style="text-align:left"><?php locale('desc_area-other') ?></th>
		<td style="text-align:right"><?php echo formatSize($size_other) ?></td>
	</tr>
	<tr>
		<th style="text-align:left;border-top:2px solid #ccc"><?php locale('desc_size-total') ?></th>
		<td style="text-align:right;border-top:2px solid #ccc"><?php echo formatSize($size_total) ?></td>
	</tr>
</table>

</body>
</html>
