<?php
/*  cms-db  Copyright (C) 2007-2010 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */

define('cms-db', 'backend');

include('checkuser.inc.php');
checkuser('template');
include('locale.inc.php');
$locale = new LocalizingClass('edit');
?>
<?php
if (isset($_POST['button'])) {
	include('escape.inc.php');
	//START
	$filename = '../data/template.tpl';
	$content = $_POST['content'];
	$content = escapeSL($content);
	if (is_writable($filename)) {

		if (!$handle = fopen($filename, "w")) {
			include('error.inc.php');
			throw_error(sprintf(locale('desc_error-open-file',true), $filename), 'template.php?'.SID.csrf_protection_get());
		}

		if (!fwrite($handle, $content)) {
			include('error.inc.php');
			throw_error(sprintf(locale('desc_error-write-file',true), $filename), 'template.php?'.SID.csrf_protection_get());
		}

		header('Location:template.php?saved=yes&'.SID.csrf_protection_get());

		fclose($handle);

	} else {
			include('error.inc.php');
			throw_error(sprintf(locale('desc_error-fileperms',true), $filename), 'template.php?'.SID.csrf_protection_get());
	}
	//ENDE
} else {
	$editmode = (isset($_GET['editmode'])) ? $_GET['editmode'] : 'text';
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title><?php locale('desc_template') ?></title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<link rel="stylesheet" type="text/css" href="style.css">
<link rel="stylesheet" type="text/css" href="<?php include('mobile.inc.php'); echo mobile() ? 'style-extra-mobile.css' : 'style-extra.css'; ?>" />
<noscript><?php locale('desc_javascript') ?></noscript>
<?php
include('../functions_url.inc.php');
if ($editmode == 'text') {
	echo '<script type="text/javascript" src="jquery.js"></script>';
	echo '<script type="text/javascript" src="jquery.textarea.js"></script>';
	echo '<script type="text/javascript">$(function () { $("textarea").tabby(); });</script>';
} elseif ($editmode == 'syntax') {
	echo '<script type="text/javascript" src="codemirror/js/codemirror.js"></script>';
	//echo '<link rel="stylesheet" type="text/css" href="codemirror/css/docs.css"/>';
	echo '
	<script type="text/javascript">
	var editor = null;
	window.onload = function () {
		editor = CodeMirror.fromTextArea("content", {
			height: "350px",
			parserfile: ["parsexml.js",
						 "parsecss.js",
						 "tokenizejavascript.js",
						 "parsejavascript.js",
						 "parsehtmlmixed.js"],
			stylesheet: ["codemirror/css/xmlcolors.css",
						 "codemirror/css/jscolors.css",
						 "codemirror/css/csscolors.css",
						 "codemirror/editstyle.css"],
			indentUnit: 4,
			tabMode: "shift",
			lineNumbers: true,
			path: "codemirror/js/",
			continuousScanning: 500
		});
	};
	// get content by editor.getCode()
	</script>';
}
?>
</head>
<body>

<h1><?php locale('desc_template') ?></h1>
<?php
if (isset($_GET['saved'])) {
	echo '<p class="hint">'.locale('desc_savedtpl',true).'</p>';
}
?>

<div class="anchormenu"><span class="leftcorner">&nbsp;</span><ul><?php
$cssclass = ($editmode == 'text') ? ' active' : '';
echo '<li><a class="nonewtab'.$cssclass.'" href="template.php?editmode=text&amp;'.SID.csrf_protection_get_html_ret().'">'.locale('link_editmode-text',true).'</a></li>';
$cssclass = ($editmode == 'syntax') ? ' active' : '';
echo '<li><a class="nonewtab'.$cssclass.'" href="template.php?editmode=syntax&amp;'.SID.csrf_protection_get_html_ret().'">'.locale('link_editmode-syntax',true).'</a></li>';
?></ul><span class="rightcorner">&nbsp;</span></div>

<p>
	<form action="template.php?<?php echo SID; csrf_protection_get_html() ?>" method="post">
		<textarea id="content" name="content" cols="80" rows="20" style="border: 1px solid #BFBFBF; font-family: Verdana; font-size: 12px;"><?php
include('getcontent.inc.php');
echo GetContent("../data/template.tpl");
?></textarea><br />
		<input type="submit" name="button" value="<?php locale('button_save') ?>">
         </form>
</p>
<p>
	<?php locale('desc_variables') ?>
	<a href="variables.php?<?php echo SID; csrf_protection_get_html() ?>"><?php locale('link_variables') ?></a>
</p>
<?php
if ($editmode == 'text') {
	include('insert.inc.php');
}
?>

</body>
</html>
<?php
}
?>
