<?php
/*  cms-db  Copyright (C) 2007-2010 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */

if (!defined('cms-db')) {
	chdir('../');
	include('friendlyerror.firewall.inc.php');
	die();
}

/* Helper function to check whether the filename is encoded in UTF-8 */
function _is_utf8($string) {
	return preg_match('%^(?:
		  [\x09\x0A\x0D\x20-\x7E]
		| [\xC2-\xDF][\x80-\xBF]
		|  \xE0[\xA0-\xBF][\x80-\xBF]
		| [\xE1-\xEC\xEE\xEF][\x80-\xBF]{2}
		|  \xED[\x80-\x9F][\x80-\xBF]
		|  \xF0[\x90-\xBF][\x80-\xBF]{2}
		| [\xF1-\xF3][\x80-\xBF]{3}
		|  \xF4[\x80-\x8F][\x80-\xBF]{2}
	)*$%xs', $string);
}

/* 
 * This function converts all pages in the specified directory to
 * sections and converts all filenames to UTF-8
 */
function _convertp2s($dir) {
	$handle = opendir($dir);
	while (false !== ($file = readdir ($handle))) {
		if ($file != "." && $file != "..") {
			if (!_is_utf8($file)) {
				$file_utf8 = utf8_encode($file);
				if ($file_utf8 != $file) {
					rename($dir.'/'.$file, $dir.'/'.$file_utf8);
					$file = $file_utf8;
				}
			}
			if (is_dir($dir.'/'.$file)) {
				_convertp2s($dir.'/'.$file);
			} elseif ($file != '01,Home') {
				mkdir($dir.'/__TEMP__');
				rename($dir.'/'.$file, $dir.'/__TEMP__/01,Home');
				rename($dir.'/__TEMP__', $dir.'/'.$file);
			}
		}
	}
	closedir($handle);
}

/* 
 * This is a helper function which should be used for invoking the
 * update
 */
function convert_pages_to_sections() {
	_convertp2s('../data/pages');
}

?>
