<?php
/*
    cms -db
    Copyright (C) 2007-2010 Jan Hoffmann

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

header('Content-Type: text/html; charset=utf-8');
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Version</title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<link rel="stylesheet" type="text/css" href="style.css">
<style type="text/css">
<!--
ul {
	list-style-type: none;
	margin: 0;
	padding: 0 0 0 .5em;
}
ul li:before {
	content: "- ";
	margin-right: .2em;
}
-->
</style>
</head>
<body>

<h1>About cms -db</h1>
<p>
    <span style="font-size: 1.25em; font-weight: bolder">
		cms -db v0.8.1 - <a href="http://cms-db.de/">http://cms-db.de/</a>
	</span><br />
    Copyright (C) 2007-2010 Jan Hoffmann<br />
	<br />
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.<br />
	<br />
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.<br />
	<br />
    You should have received a copy of the GNU General Public License
    along with this program. If not, see http://www.gnu.org/licenses/.
</p>
<p>
	<a href="gnu-gpl.php">Click here to read the full license.</a>
</p>
<h2>Translators</h2>
<ul>
<?php
if ($handle = opendir('./locales')) {
	while (false !== ($file = readdir($handle))) {
		if(is_file('./locales/'.$file.'/info.php')) {
			include('./locales/'.$file.'/info.php');
			echo '<li><strong>'.$locale_info['name'].':</strong> '.$locale_info['authors'].'</li>';
		}
	}
	closedir($handle);
}
?>
</ul>
<h2>Thanks to the developers</h2>
<ul>
	<li><a href="http://marijn.haverbeke.nl/codemirror/" target="_blank">CodeMirror</a></li>
	<li><a href="http://jquery.com/" target="_blank">jQuery + jQuery UI</a></li>
	<li><a href="http://oxygen-icons.org/" target="_blank">Oxygen Icon Theme</a></li>
	<li><a href="http://www-kaa.phpconcept.net/pclzip" target="_blank">PclZip</a></li>
	<li><a href="http://teddevito.com/demos/textarea.html" target="_blank">Tabby jQuery plugin</a></li>
	<li><a href="http://www.phpclasses.org/browse/package/945.html" target="_blank">TAR Archive Class (modified)</a></li>
	<li><a href="http://wymeditor.org/" target="_blank">WYMeditor</a></li>
</ul>
<h2>Changelog</h2>
<h3>v0.1</h3>
<ul>
	<li>First version</li>
</ul>
<h3>v0.1.1</h3>
<ul>
	<li>Improved icons</li>
</ul>
<h3>v0.1.2</h3>
<ul>
	<li>TinyMCE was downsized (from 2,2MiB to 1,6MiB)</li>
	<li>Integration of TinyMCE in Includes and Template</li>
</ul>
<h3>v0.2</h3>
<ul>
	<li>Completely new admin interface</li>
</ul>
<h3>v0.2.1</h3>
<ul>
	<li>Admin interface now supports MSIE</li>
</ul>
<h3>v0.2.2</h3>
<ul>
	<li>Various Bugfixes</li>
</ul>
<h3>v0.2.3</h3>
<ul>
	<li>Bugfixes</li>
</ul>
<h3>v0.2.4</h3>
<ul>
	<li>Security code in guestbook is transmitted via SESSION (99,9% safe)</li>
</ul>
<h3>v0.2.5</h3>
<ul>
	<li>Bugfix for the FTP link in the admin interface (only affects servers with safe_mode=1)</li>
	<li>Work-around for a PHP bug which can occur on certain PHP configurations</li>
</ul>
<h3>v0.2.6</h3>
<ul>
	<li>Improved security code in guestbook</li>
</ul>
<h3>v0.2.7</h3>
<ul>
	<li>Bugfixes</li>
</ul>
<h3>v0.2.8</h3>
<ul>
	<li>Redirection in pages</li>
	<li>Improved display of file permissions</li>
</ul>
<h3>v0.2.9</h3>
<ul>
	<li>It is now possible to split the admin interface</li>
</ul>
<h3>v0.2.10</h3>
<ul>
	<li>Shorter URLs ("sec" and "sub" dropped out)</li>
	<li>Menus and sitemap are now lists</li>
</ul>
<h3>v0.2.11</h3>
<ul>
	<li>Folding menu</li>
</ul>
<h3>v0.2.12</h3>
<ul>
	<li>URL rewriting is now possible</li>
	<li>"file=" dropped out of the page URLs</li>
</ul>
<h3>v0.2.13</h3>
<ul>
	<li>Small changes/bugfixes in search function
		<ul>
			<li>Adjusting the cache for new URLs</li>
			<li>HTML entities in search results</li>
		</ul>
	</li>
	<li>Better display while extracting backups</li>
</ul>
<h3>v0.2.14</h3>
<ul>
	<li>Improved icons</li>
	<li>Small bugfixes</li>
</ul>
<h3>v0.2.15</h3>
<ul>
	<li>Changes in configuration of TinyMCE (XHTML 1.1-doctype)</li>
	<li>Adjusted page impressions function for new URLs</li>
	<li>No unnecessary cookies on website (where possible)</li>
</ul>
<h3>v0.2.16</h3>
<ul>
	<li>Improved admin interface</li>
	<li>Bugfix for redirections</li>
</ul>
<h3>v0.2.17</h3>
<ul>
	<li>Changing background color and text color of desktop of admin interface now possible</li>
	<li>Clock in the admin interface</li>
	<li>Improved login page</li>
</ul>
<h3>v0.3</h3>
<ul>
	<li>Remove of invalid tag in /admin/frame.php which avoided displaying the javascript warning</li>
	<li>Compatibility mode for MSIE and browsers without Javascript</li>
	<li>Bugfix: When creating/renaming files with special chars there's no PHP error anymore</li>
	<li>Guestbook is valid XHTML (%%GUESTBOOK%% must not be placed in a p-element!)</li>
	<li>New default template</li>
	<li>Browser and OS stats</li>
	<li>Bugfix for admin interface split</li>
</ul>
<h3>v0.3.1</h3>
<ul>
	<li>If browser and/or OS is unknown the user agent is saved now</li>
</ul>
<h3>v0.3.2</h3>
<ul>
	<li>Bots of search engines are now listed as the OS "Bot"</li>
</ul>
<h3>v0.3.3</h3>
<ul>
	<li>Improved readout of stats</li>
	<li>Bugfix for OS detection</li>
	<li>Bugfix in stats page</li>
</ul>
<h3>v0.3.4</h3>
<ul>
	<li>Bugfix: Bots are now displayed as OS "Bot" instead of "unbekanntBot"</li>
</ul>
<h3>v0.3.5</h3>
<ul>
	<li>When a page is not found the HTTP status code "404 Not Found" is now sent</li>
</ul>
<h3>v0.3.6</h3>
<ul>
	<li>The 404 error message is now also displayed if the requested file is a folder (instead of a PHP error)</li>
	<li>Improved stats: Recognition of more bots</li>
	<li>Bots can now be hidden when displaying stats</li>
</ul>
<h3>v0.3.7</h3>
<ul>
	<li>All copyright notes updated to 2008</li>
</ul>
<h3>v0.3.8</h3>
<ul>
	<li>Bugfix (Folding menu only showed 2 layers)</li>
	<li>Code of /admin/upload.php was tidied up</li>
</ul>
<h3>v0.4</h3>
<ul>
	<li>Changing displayed name of 01,Home is now possible</li>
	<li>Search without cache</li>
	<li>Revision of /page/index.php</li>
	<li>Variables for $beforeurl, $afterurl and $absoluteurl</li>
	<li>Multiple users</li>
	<li>New icon navigation in admin interface</li>
	<li>PclZip is used to create and extract backups</li>
	<li>Bugfixes for guestbook</li>
	<li>New default template of website (old design of cms-db.de)</li>
	<li>Update to TinyMCE 3</li>
	<li>New symbol for the website view</li>
	<li>New log on and off screen</li>
	<li>Warning at logout</li>
	<li>Recycling Center</li>
	<li>Renaming files and includes is now possible</li>
	<li>Bugfix for Opera</li>
</ul>design
<h3>v0.4.1</h3>
<ul>
	<li>Bugfix: When creating/renaming a file/include and inserting a filename already existing, the file was overwritten</li>
</ul>
<h3>v0.4.2</h3>
<ul>
	<li>Bugfix: Until now all variables were replaced insted of only the ones used in the template. Parsing of pages should now be faster when not using many variables.</li>
</ul>
<h3>v0.5</h3>
<ul>
	<li>
		New structure of folders:
		<ul>
			<li>The <i>index.php</i> generating the pages is now located in the root folder, the admin interface is still in <i>/admin</i> and the folder <i>/data</i> contains everything needing write permissions. (Updates are now possible)</li>
			<li>The CMS has to be re-installed, an update to v0.5 is not possible.</li>
		</ul>
	</li>
	<li>Bugfix: In the search results variables aren't replaced anymore</li>
	<li>Oxygen Icon Theme instead of Crystal Icon Theme</li>
	<li>Complete backup</li>
</ul>
<h3>v0.5.1</h3>
<ul>
	<li>New font and font size in admin interface</li>
	<li>Bugfix: Inserting page and file links in includes is now adjusted for the new folder structure</li>
</ul>
<h3>v0.6</h3>
<ul>
	<li>cms -db is now localizable</li>
	<li>Pages are now sent with XHTML header (Content-type: application/xhtml+xml), if the web browser claims to support XHTML</li>
	<li>Overlay of admin interface when the logout warning is displayed</li>
	<li>Utilisation of jQuery in admin interface</li>
	<li>The variable $query_string_data contains the part of the query strings behind <i>~~~</i> now (can be accessed in includes using <i>global</i>)</li>
	<li>Tabs in admin interface</li>
	<li>%%PAGETITLE%% contains only the name of current page now (the old variable is available as %%FULLTITLE%%)</li>
	<li>New design for the icon bar</li>
	<li>The search function displays the search term bold now</li>
	<li>New default template</li>
	<li>Change in the order of replacing variables while parsing pages</li>
	<li>WYMeditor instead of TinyMCE</li>
	<li>Automatically generated XML sitemap (sitemap.php)</li>
	<li>The HTTP status code 301 is sent for redirects now</li>
	<li>Update of the guestbook and its management</li>
	<li>%%LEFTMENU%% does not show the home page anymore</li>
	<li>Short URLs</li>
	<li>FTP settings removed</li>
	<li>New browser und OS detection</li>
	<li>New variable for displaying a link list for the current section</li>
	<li>Paragraphs around %%GUESTBOOK%%, %%SITEMAP%%, %%INCLUDE%%, %%SECTIONLIST%% and %%LOGINFORM%% are now removed automatically</li>
	<li>Better check for problems while creating pages</li>
	<li>Keeping alive the session while editing pages</li>
	<li>%%LEFTMENU%% is replaced by %%COMPLETESUBMENU%% and %%FOLDINGSUBMENU%%</li>
	<li>There are only pages now (behaving like sections in older versions)</li>
	<li>Variable to display a login form for the admin interface</li>
	<li>Before installing a backup existing files are removed</li>
	<li>Old data is recovered if installing a backup fails</li>
	<li>Bugfix: Sub pages are now displayed in all menus</li>
	<li>Bugfix: Inserted links work correctly now</li>
	<li>Bugfix: When moving multiple pages into the recycling center no pages are lost anymore</li>
	<li>Bugfix: Recovering pages is possible now</li>
	<li>Bugfix: HTML entities aren't removed while editing anymore</li>
	<li>Bugfix: Sub menus do not show pages in the root folder anymore when the search results or an error page are displayed ($sec and $sub are empty then)</li>
</ul>
<h3>v0.6.1</h3>
<ul>
	<li>New tabs can be opened by double clicking the tab bar</li>
	<li>The slash is now used to devide query strings instead of three tildes (~~~)</li>
	<li>Passwords are now saved as a salted hash</li>
	<li>Safe password editing in the admin interface</li>
	<li>Bugfix: URLs in the XML sitemap are now correct</li>
	<li>Bugfix: An &amp; in pages names does not cause an error in XHTML compatible browser anymore</li>
	<li>Bugfix: Quotation marks in page names do not cause errors anymore</li>
	<li>Vulnerability Fix: Old URLs are not redirected to the new ones anymore (was a security hole)</li>
</ul>
<h3>v0.7</h3>
<ul>
	<li>Blog function (blog and guestbook mustn't be used on the same page)</span></li>
	<li>Attributes rel, rev and style are now allowed in editor</li>
	<li>Small improvements to the editor</li>
	<li>The complete menus and folding menus now have a new class activeli{i} or inactiveli{i} in every <i>li</i> element ({i} = layer)</li>
	<li>TOPMENU has a new class topactiveli or topinactiveli in every <i>li</i> element now</li>
	<li>Redirections are now linked directly</li>
	<li>Menus and sitemap are now saved in a cache</li>
	<li>There is an English translation now</li>
	<li>The tab function uses jQuery now</li>
	<li>Links on the website can now be opened in a new window (javascript is necessary)</li>
	<li>Anchors can now be created and linked in the editor</li>
	<li>Nice URLs for page names in Chinese, Turkish, Russian, Polish, Czech, Greek and many other languages</li>
	<li>Loading screen</li>
	<li>Changelog is now English</li>
	<li>It is now possible to open any link in the admin interface in a new tab by clicking on the icon left to it</li>
	<li>Links in the menu, the icon bar and on the desktop can now be opened in a new browser tab or browser window</li>
	<li>It is now possible to escape the % character by writing \%</li>
	<li>The language can now be changed using %%FORCELANGUAGE-LANGCODE%%</li>
	<li>The search can now be used with the attribute <i>lang</i> to change the language</li>
	<li>Special version of the admin interface for mobile phones</li>
	<li>New template (removes bugs in the old one)</li>
	<li>Includes are now done without callback (allows access to the template class via $this)</li>
	<li>Integration of the Tabby jQuery plugin which allows typing tabs in textareas</li>
	<li>The PHP mbstring extension is now used where possible and useful</li>
	<li>Improved page management and settings interface</li>
	<li>The data folder is now protected using a htaccess file (there was a security hole after creating a complete backup)</li>
	<li>Update of jQuery to version 1.3.2</li>
	<li>Update of WYMeditor to version 0.5rc1</li>
	<li>Better Support for Internet Explorer</li>
	<li>Small improvements in the spam protection of the guestbook</li>
	<li>E-mail is needed in guestbook and website can be added</li>
	<li>Better support for special chars in page titles</li>
	<li>Pages are now automatically saved every 30 seconds while editing</li>
	<li>Condition variable</li>
	<li>Late includes</li>
	<li>Better design of the admin area</li>
	<li>Files and includes are now sorted alphabetically</li>
	<li>Bugfix: When closing tabs opened from the menu the admin interface doesn't reload anymore</li>
	<li>Bugfix: The usage of multiple menus in a single page doesn't cause senseless output anymore</li>
	<li>Bugfix: sitemap.php sends the correct header now</li>
	<li>Bugfix: Support for special chars in URLs</li>
	<li>Bugfix: If the URL index is invalid there is no data loss anymore</li>
	<li>Bugfix: Sub pages should be correctly marked as active in the menus</li>
	<li>Bugfix: Sub pages can now be sorted</li>
</ul>
<h3>v0.7.1</h3>
<ul>
	<li>Variable which displays a list of the ten latest blog entries</li>
	<li>More detailed information about variables</li>
	<li>Allow clearing floats in the editor</li>
	<li>Bugfix: Special chars in the blog title don't cause any errors anymore</li>
	<li>Bugfix: Inserting image filenames in the editor does work again</li>
	<li>Bugfix: Links to files don't have a useless anchor anymore</li>
</ul>
<h3>v0.7.2</h3>
<ul>
	<li>The list of the last ten blog articles has the class <i>date</i> for the date now</li>
	<li>Anchor menu for includes and files</li>
	<li>Detection of mobile browsers and newer browser versions</li>
	<li>Bugfix: Sorting files and includes is now case insensitive</li>
	<li>Bugfix: Default icon for new tabs</li>
	<li>Bugfix: Browsers are now sorted in the stats</li>
</ul>
<h3>v0.7.3</h3>
<ul>
	<li>XHTML header can be disabled</li>
	<li>Cache is disabled by default (can be turned on in settings)</li>
	<li>Bugfix: Update from an older version than 0.7.1 works</li>
</ul>
<h3>v0.7.4</h3>
<ul>
	<li>Work around problems with T-Mobile's compression</li>
	<li>Bugfix: Files can now be accessed again after restoring a backup</li>
</ul>
<h3>v0.7.5</h3>
<ul>
	<li>Contact form</li>
	<li>New backup format</li>
	<li>AltGr+Tab and Super+Tab switch between the tabs now (could be broken in some browsers)</li>
	<li>Detection of more mobile operating systems and browsers</li>
</ul>
<h3>v0.7.6</h3>
<ul>
	<li>Visitor counter</li>
	<li>Entries in the IP list time out after 24 hours</li>
	<li>Better implementation for data format update with old backup format</li>
	<li>Bugfix: No error on update from an older version than 0.7.3</li>
	<li>Bugfix: Mobile markup works with lists</li>
	<li>Bugfix: The last edit variable works again</li>
</ul>
<h3>v0.7.7</h3>
<ul>
	<li>More finger friendly design for mobile version</li>
	<li>Admin interface type can be chosen by user in login screen</li>
	<li>Better page sorting using jQuery UI</li>
	<li>The file permissions in the data directory can now be changed in case of problems</li>
	<li>Some small memory optimizations</li>
	<li>Preparation for new page format</li>
	<li>More blog options</li>
	<li>Bugfix: Adding the IP to the list wasn't updated to new format</li>
	<li>Bugfix: The blog cache gets deleted when deleting an article</li>
	<li>Bugfix: The charset is now always set in the HTTP header (removes problems with umlauts and special chars)</li>
	<li>Bugfix: The stats and the user counter work correctly</li>
</ul>
<h3>v0.7.8</h3>
<ul>
	<li>Detection of new browsers</li>
	<li>Nicer first start design</li>
	<li>The website is now inaccessible during updates</li>
	<li>Bugfix: New IP list implementation removes problems with ram usage</li>
</ul>
<h3>v0.7.9</h3>
<ul>
	<li>Bugfix: Blog links and comments work again</li>
	<li>Bugfix: Peak memory usage is only printed in comment if available</li>
</ul>
<h3>v0.7.10</h3>
<ul>
	<li>Notification for new updates</li>
	<li>Italian translation</li>
	<li>Clarification about saving pages (now called drafts)</li>
	<li>Credits for translations through the web interface</li>
	<li>The contact form may work better on some servers now</li>
	<li>Bugfix: Single quotes in locale strings shouldn't cause errors anymore</li>
	<li>Bugfix: The clock is now translated</li>
</ul>
<h3>v0.7.11</h3>
<ul>
	<li>Automatic update through the admin interface</li>
	<li>Starting the first run assistant is now easier</li>
	<li>Nicer design of the disk space display</li>
	<li>Usage of escaping functions in more places</li>
	<li>Small preparations for PHP 5.3 and 6.0</li>
</ul>
<h3>v0.7.12</h3>
<ul>
	<li>Variables for blog feeds</li>
	<li>Detection of newer versions of Opera</li>
	<li>Bugfix: No useless new tab buttons in Webkit browsers</li>
	<li>Bugfix: Problems with rights when updating are resolved</li>
</ul>
<h3>v0.7.13</h3>
<ul>
	<li>Complete url variable</li>
	<li>The variables page is better structured</li>
	<li>When inserting an image in WYMeditor with an empty alternative text, a space is automatically added as alt attribute</li>
	<li>The page and file lists in the editor are automatically updated</li>
	<li>Redesign of the password change feature</li>
	<li>Bugfix: Creating multiple blog entries at the same time doesn't lead to data loss</li>
	<li>Bugfix: When a user changes his password the user rights are retained</li>
</ul>
<h3>v0.8</h3>
<ul>
	<li>Syntax highlighting for includes and template using CodeMirror</li>
	<li>Uploaded text files can be edited (with syntax highlighting for some formats)</li>
	<li>Improved mobile version of the file and include management as well as the recycling center</li>
	<li>Inserting links to pages or files uses the new  mobile "linklist" style</li>
	<li>The complete path of pages can be used for generating the URLs</li>
	<li>Code cleanup in the menus</li>
	<li>Workaround for a IE bug that caused the editor to not load</li>
	<li>Fix for URL problems with special chars on some servers</li>
	<li>Updated jQuery to version 1.4</li>
	<li>Links to files and image previews</li>
	<li>Full PHP 5.3 compatibility</li>
	<li>Easier editing of tags in the blog</li>
	<li>Page Attributes</li>
	<li>More detailed disk space overview</li>
	<li>Autosave for blog entries</li>
	<li>Updated various small parts with bad code style</li>
	<li>Tablet Version</li>
	<li>Bugfix: The folding submenu does now always work correctly</li>
	<li>Bugfix: The context sensitive blog feed variable produces correct links</li>
	<li>Bugfix: URLs to files inserted with the editor are correct</li>
	<li>Bugfix: E-Mails sent using the contact form are marked as UTF-8 in the header</li>
	<li>Bugfix: Backslashes are only stripped if necessary</li>
	<li>Bugfix: The guestbook (blog comments) works as it should work after deleting an entry</li>
	<li>Bugfix: Ampersands in page names are displayed correctly</li>
	<li>Bugfix: Update from versions without locale support works better</li>
	<li>Vulnerability Fix: Always require a security hash to prevent CSRF attacks (<a href="http://www.exploit-db.com/exploits/10648">EDB #10648</a>)</li>
	<li>Vulnerability Fix: Minor XSS security hole in LocalizingClass (<a href="http://www.exploit-db.com/exploits/10648">EDB #10648</a>)</li>
	<li>Vulnerability Fix: Full Path Disclosure (PHP errors) in several files (<a href="http://www.exploit-db.com/exploits/10648">EDB #10648</a>)</li>
</ul>
<h3>v0.8.1</h3>
<ul>
	<li>Slightly updated admin area design</li>
	<li>Possibility to sort pages alphabetically</li>
	<li>Updated WYMeditor to fix cursor bug in Firefox 3.6</li>
	<li>Updated PclZip (will be obsolete soon)</li>
	<li>Anchor menu in more places</li>
	<li>Bugfix: No more CSRF protection error when hiding/showing page</li>
	<li>Bugfix: Links to files can be inserted</li>
	<li>Bugfix: Javascript window.onload event works on the website</li>
	<li>Bugfix: Drafts of pages are now always deleted when publishing the page</li>
	<li>Bugfix: User change works</li>
</ul>
<!--
	<li>TODO:
		<ul>
			<li>Sub-folders for files (TODO: restoring)</li>
			<li>Move pages</li>
			<li>login/checkuser: check for right cms-db installation on the server</li>
			<li>usage of page attributes for search</li>
		</ul>
	</li>
-->

<!-- Don't forget to update /admin/update/version.txt -->

</body>
</html>
