<?php
/*  cms-db  Copyright (C) 2007-2010 Jan Hoffmann
            Copyright (C) 2008 Mario Fähland
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */

if (!defined('cms-db')) {
	chdir('./admin');
	include('friendlyerror.firewall.inc.php');
	die();
}

function createTopMenu() {
	$output = '';
	global $sec, $home;
	$output .= '<ul class="topmenu">';
	$ordner = './data/pages';
	$handle = opendir($ordner);
	while (false !== ($file = readdir($handle))) {
		if($file != "." && $file != "..") {
			$pos = strpos($file, ".DEL");
			if ($pos === false) {
				if(is_dir($ordner."/".$file)) {
					$files[] = $file;
				}
			}
		}
	}
	natcasesort($files);
	foreach($files as $file) {
		if ($file == '01,Home') {
			$show = $home;
		} else {
			$show = substr($file, 3);
			$show = str_replace('_', ' ', $show);
			$show = str_replace('SLASH', '/', $show);
			$show = str_replace('AND', '&', $show);
		}
		if($sec != $file) {
			$output .= '<li class="topinactiveli"><a href="'.get_full_url(substr($ordner,12).'/'.$file.'/01,Home').'" class="topinactive">'.htmlspecialchars($show).'</a></li>';
		} else {
			$output .= '<li class="topactiveli"><a href="'.get_full_url(substr($ordner,12).'/'.$file.'/01,Home').'" class="topactive">'.htmlspecialchars($show).'</a></li>';
		}
	}
	closedir($handle);
	$output .= '</ul>';
	return $output;
}

function createSitemap($ordner, $count = 0) {
	if (!isset($output)) { static $output = ''; }
	global $home;
	$handle = opendir($ordner);
	while (false !== ($file = readdir($handle))) {
		if($file != "." && $file != "..") {
			$pos = strpos($file, ".DEL");
			if ($pos === false) {
				if(is_dir($ordner."/".$file)) {
					$dirs[] = $ordner."/".$file;
				}
			}
		}
	}
	closedir($handle);
	if (isset($dirs)) {
		$output .= '<ul class="sitemap'.$count.'">';
		natcasesort($dirs);
		foreach($dirs as $dir) {
			$file = str_replace($ordner."/","",$dir);
			if ($file == '01,Home') {
				$show = $home;
			} else {
				$show = substr($file, 3);
				$show = str_replace('_', ' ', $show);
				$show = str_replace('SLASH', '/', $show);
				$show = str_replace('AND', '&', $show);
			}
			$output .= '<li class="dirli'.$count.'"><a href="'.get_full_url(substr($ordner,12).'/'.$file.'/01,Home').'" class="dirlink'.$count.'">'.htmlspecialchars($show).'</a>';
			createSitemap($dir, $count+1);
			$output .= '</li>';
		}
		$output .= '</ul>';
	}
	return $output;
}

function createCompleteMenu($ordner, $count = 0) {
	$output = '';
	global $home, $splitfile;
	$handle = opendir($ordner);
	while (false !== ($file = readdir($handle))) {
		if($file != "." && $file != "..") {
			$pos = strpos($file, ".DEL");
			if ($pos === false) {
				if(is_dir($ordner."/".$file)) {
					$dirs[] = $ordner."/".$file;
				}
			}
		}
	}
	closedir($handle);
	if (isset($dirs)) {
		$countsub = substr_count(substr($ordner,12), '/')+1;
		$output .= '<ul class="menu'.$count.'">';
		natcasesort($dirs);
			foreach($dirs as $dir) {
			$file = str_replace($ordner."/","",$dir);
			if ($file == '01,Home') {
				$show = $home;
			} else {
				$show = substr($file, 3);
				$show = str_replace('_', ' ', $show);
				$show = str_replace('SLASH', '/', $show);
				$show = str_replace('AND', '&', $show);
			}
			if ($splitfile[$countsub] == $file) {
				$output .= '<li class="activeli'.$count.'"><a href="'.get_full_url(substr($ordner,12).'/'.$file.'/01,Home').'" class="active'.$count.'">'.htmlspecialchars($show).'</a>';
			} else {
				$output .= '<li class="inactiveli'.$count.'"><a href="'.get_full_url(substr($ordner,12).'/'.$file.'/01,Home').'" class="inactive'.$count.'">'.htmlspecialchars($show).'</a>';
			}
			$output .= createCompleteMenu($dir, $count+1);
			$output .= '</li>';
		}
		$output .= '</ul>';
	}
	return $output;
}

function createFoldingMenu($ordner, $count = 0, $force_folding = false) {
	$output = '';
	global $home, $splitfile;
	$handle = opendir($ordner);
	while (false !== ($file = readdir($handle))) {
		if($file != '.' && $file != '..') {
			$pos = strpos($file, '.DEL');
			if ($pos === false) {
				if(is_dir($ordner.'/'.$file)) {
					$dirs[] = $ordner.'/'.$file;
				}
			}
		}
	}
	closedir($handle);
	if (isset($dirs)) {
		$output .= '<ul class="menu'.$count.'">';
		$replace1 = array('%2F','%2C');
		$replace2 = array('/',',');
		natcasesort($dirs);
		foreach($dirs as $dir) {
			if ($count == 0) {
				$force_folding = false;
			}
			$file = str_replace($ordner."/","",$dir);
			if ($file == '01,Home') {
				$show = $home;
			} else {
				$show = substr($file, 3);
				$show = str_replace('_', ' ', $show);
				$show = str_replace('SLASH', '/', $show);
				$show = str_replace('AND', '&', $show);
			}
			$countsub = substr_count(substr($ordner,12).'/'.$file, '/');
			if (isset($splitfile[$countsub]) && $splitfile[$countsub] == $file) {
				$output .= '<li class="activeli'.$count.'"><a href="'.get_full_url(substr($ordner,12).'/'.$file.'/01,Home').'" class="active'.$count.'">'.htmlspecialchars($show).'</a>';
			} else {
				$output .= '<li class="inactiveli'.$count.'"><a href="'.get_full_url(substr($ordner,12).'/'.$file.'/01,Home').'" class="inactive'.$count.'">'.htmlspecialchars($show).'</a>';
			}
			if ((isset($splitfile[$countsub]) && $splitfile[$countsub] == $file) || $force_folding == true) {
				$output .= createFoldingMenu($dir, $count+1, $force_folding = true);
			}
			$output .= '</li>';
		}
		$output .= '</ul>';
	}
	return $output;
}

function PageCount() {
	global $query_string, $file;
	if (is_file($file)) {
		if ($file == './data/pages/01,Home/01,Home') {
			$shorturl = 'home';
		} else {
			$shorturl = $query_string[0];
		}
		if (file_exists('./data/counter/'.$shorturl)) {
			$count = file_get_contents('./data/counter/'.$shorturl);
			$count++;
			file_put_contents('./data/counter/'.$shorturl, $count);
			$output = $count;
		} else {
			file_put_contents('./data/counter/'.$shorturl, '1');
			$output = '1';
		}
	}
	return $output;
}
function LastEdit() {
	global $file;
	if ($_GET['special'] != 'search' && file_exists($file)) {
		$filetime = filemtime($file);
		if($filetime == false) {
			$LastEdit = "-";
		} else {
			$LastEdit = date("d.m.Y H:i", $filetime);
		}
	} else {
		$LastEdit = '-';
	}
	return $LastEdit;
}

function getFullPageTitle($title_temp) {
	global $home;
	$pagetitle = '';
	//$title_temp = substr($folder.'/'.$file, 13);
	$title = explode('/', $title_temp);
	$first = 1;
	foreach($title as $text) {
		if ($first == 0) {
			$pagetitle .= ' > ';
		}
		if ($text == '01,Home') {
			$text = $home;
		} else {
			$text = substr($text, 3);
			$text = str_replace('_', ' ', $text);
			$text = str_replace('SLASH', '/', $text);
			$text = str_replace('AND', '&', $text);
		}
		$pagetitle .= $text;
		$first = 0;
	}
	$pagetitle = str_replace(' > '.$home, '', $pagetitle);
	$pagetitle = str_replace('.DEL', '', $pagetitle);
	$pagetitle = htmlspecialchars($pagetitle);
	return $pagetitle;
}

function getBreadCrumbs() {
	if ($_GET['special'] != 'search') {
		global $file, $home;
		$BreadCrumbs = '';
		$title_temp = substr($file, 13);
		$title = explode('/', $title_temp);
		$first = 1;
		$count = count($title) - 1;
		for($i = 0; $i < $count; $i++) {
			$text = $title[$i];
			if ($first == 0) {
				$BreadCrumbs .= ' &gt; ';
			}
			if ($text == '01,Home') {
				$text = $home;
			} else {
				$text = substr($text, 3);
				$text = str_replace('_', ' ', $text);
				$text = str_replace('SLASH', '/', $text);
				$text = str_replace('AND', '&', $text);
			}
			if ($i + 1 < $count) {
				$path = '';
				for($n = 0; $n <= $i; $n++) {
					$path .= '/'.$title[$n];
				}
				$BreadCrumbs .= '<a href="'.get_full_url($path.'/01,Home').'">'.$text.'</a>';
			} else {
				$BreadCrumbs .= $text;
			}
			$first = 0;
		}
		$BreadCrumbs = str_replace('.DEL', "", $BreadCrumbs);
	} else {
		$BreadCrumbs = '//search//';
	}
	return $BreadCrumbs;
}

function getContentPreview($preview, $pos) {
	if ( ($pos-100) > 0 && ($pos+100) < _strlen($preview) ) {
		$preview = '...'._substr($preview, $pos-100, 200).'...';
	} elseif ( ($pos-200 )> 0 && $pos < _strlen($preview)) {
		$preview = '...'._substr($preview, -200, 200);
	} elseif (_strlen($preview) > 200) {
		$preview = _substr($preview, 0, 200).'...';
	}
	return $preview;
}

function doSearch($keyword, $folder = './data/pages', $show_output = true) {
	global $home;
	global $urlbefore;
	global $urlafter;
	if (!isset($found)) {
		static $found = false;
	}
	if (!isset($search_matches)) {
		static $search_matches = '';
	}
	$keyword = htmlspecialchars($keyword);
	if ($keyword != '' && $keyword != ' ') {
		$handle = opendir($folder);
		while (false !== ($file = readdir ($handle))) {
			if ($file != "." && $file != "..") {
				if (is_file($folder.'/'.$file)) {
					$content = file_get_contents($folder.'/'.$file);
					# TODO: search meta attributes (description, keywords)
					$content = explode("\n".'EOC'."\n", $content);
					$content = $content[0];
					$blog = (strpos($content, '%%BLOG') !== false) ? true : false;
					# replaced by the 2 following lines
					# $content = strip_tags($content);
					$content = preg_replace('/<[\/\!]*?[^<>]*?>/', ' ', $content); 
					$content = preg_replace('/\s+/', ' ', $content);
					$content = preg_replace('/%%(.*)%%/', '', $content);
					$content = trim($content);
					$pos_title = _stripos($folder.'/'.$file, $keyword);
					$pos_content = _stripos($content, $keyword);
					# TODO: foreach ($keyword [Trennzeichen=' '])
					if ($pos_title !== false or $pos_content !== false) {
						$found = true;

						$pagetitle = getFullPageTitle(substr($folder.'/'.$file, 13));

						$url = substr($folder.'/'.$file, 12);
						$url = get_full_url($url);
						
						$preview = getContentPreview($content, $pos_content);
						
						$pagetitle = _eregi_replace('('.$keyword.')', '<strong>\\1</strong>', $pagetitle);
						$preview = _eregi_replace('('.$keyword.')', '<strong>\\1</strong>', $preview);
						$search_matches .= '<p><a href="'.$url.'">'.$pagetitle.'</a><br />'.$preview.'</p>';
					}
					if ($blog) {
						if ($h = opendir('./data/blog/articles')) {
							while (false !== ($f = readdir($h))) {
								if ($f != '.' && $f != '..') {
									$articles[] = $f;
								}
							}
							closedir($h);
						}
						if (isset($articles)) {
							natsort($articles);
							$articles = array_reverse($articles);
							foreach ($articles as $article) {
								$content = file_get_contents('./data/blog/articles/'.$article.'/content');
								$content = explode("\n", $content);
								$title = $content[0];
								$content = preg_replace('/<[\/\!]*?[^<>]*?>/', ' ', $content[4]); 
								$content = preg_replace('/\s+/', ' ', $content);
								$content = trim($content);
								$pos_title = _stripos($title, $keyword);
								$pos_content = _stripos($content, $keyword);
								if ($pos_title !== false or $pos_content !== false) {
									$found = true;
									$url = $urlbefore.get_short_url(substr($folder.'/'.$file, 12)).'/articles/'.$article.$urlafter;
									$title = getFullPageTitle(substr($folder.'/'.$file, 13)).' &gt; '.$title;
									$preview = getContentPreview($content, $pos_content);
									$title = _eregi_replace('('.$keyword.')', '<strong>\\1</strong>', $title);
									$preview = _eregi_replace('('.$keyword.')', '<strong>\\1</strong>', $preview);
									$search_matches .= '<p><a href="'.$url.'">'.$title.'</a><br />'.$preview.'</p>';
								}
							}
						}
					}
				} else {
					doSearch($keyword, $folder.'/'.$file, false);
				}
			}
		}
		closedir($handle);
		if ($show_output == true) {
			$output = '';
			$keyword_display = $keyword;
			if ($keyword_display == 'windows' or $keyword_display == 'Windows') { $keywords = array('Müll', 'Virus', 'Sicherheitslücke', 'Spyware'); $keyword_display = $keywords[rand(0,3)]; }
			if ($found == true) {
				$output .= '<p>'.sprintf(locale('desc_search-found',true), $keyword_display).'</p>';
				$output .= $search_matches;
			} elseif ($found == false) {
				$output .= '<p>'.sprintf(locale('desc_search-not-found',true), $keyword_display).'</p>';
			}
		}
	} else {
		$output = locale('desc_missing-keyword',true);
	}

	if (isset($output)) {
		return $output;
	}
}

function SectionList() {
	global $home;
	global $urlbefore;
	global $urlafter;
	global $splitfile;
	$found = false;
	$list = '';
	$folder = './data/pages';
	$i = 1;
	while($i+1 < count($splitfile)) {
		$folder .= '/'.$splitfile[$i];
		$i++;
	}
	$handle = opendir($folder);
	$files = array();
	while (false !== ($file = readdir ($handle))) {
		$files[] = $file;
	}
	natcasesort($files);
	foreach($files as $file) {
		if ($file == '01,Home') {
			continue;
		}
		if ($file != "." && $file != "..") {
			if (is_file($folder.'/'.$file)) {
				$filename = $folder.'/'.$file;
			} elseif (is_dir($folder.'/'.$file)) {
				$filename = $folder.'/'.$file.'/01,Home';
			}
			$content = file_get_contents($filename);
			# Ersetzt durch die folgenden zwei Zeilen
			# $content = strip_tags($content);
			$content = preg_replace('/<[\/\!]*?[^<>]*?>/', ' ', $content); 
			$content = preg_replace('/\s+/', ' ', $content);
			$content = preg_replace('/%%(.*)%%/', '', $content);
			$content = trim($content);
			$found = true;
			$pagetitle = substr($file, 3);
			$pagetitle = str_replace('_', ' ', $pagetitle);
			$pagetitle = str_replace('SLASH', '/', $pagetitle);
			$pagetitle = str_replace('AND', '&', $pagetitle);
			$pagetitle = str_replace('.DEL', '', $pagetitle);
			$url = substr($filename, 12);
			$url = get_full_url($url);
			if (strlen($content) > 200) {
				$preview = substr($content, 0, 200).'...';
			} else {
				$preview = $content;
			}
			$list .= '<li class="listline"><a href="'.$url.'">'.htmlspecialchars($pagetitle).'</a><br />'.$preview.'</li>';
		}
	}
	closedir($handle);
	$output = '';
	if ($found == true) {
		$output .= '<ul class="listing">'.$list.'</ul>';
	} else {
		chdir('./admin');
		$locale = new LocalizingClass('frontend', $locale_default);
		chdir('../');
		$output .= '<p>'.sprintf(locale('desc_no-pages',true), $folder).'</p>';
		unset($locale);
	}
	return $output;
}

function LoginForm() {
	global $locale_default, $urlabsolute;
	chdir('./admin');
	$locale = new LocalizingClass('index', $locale_default);
	chdir('../');
	$o  = '<form id="cms-db_login" action="'.$urlabsolute.'/admin/login.php" method="post"><p>';
	$o .= '<input type="hidden" name="locale" value="'.$locale_default.'" />';
	$o .= '<input type="text" name="user" id="user" value="" /> <label for="user">'.locale('label_username', true, $locale).'</label><br />';
	$o .= '<input type="password" name="pass" id="pass" value="" /> <label for="pass">'.locale('label_password', true, $locale).'</label><br />';
	$o .= '<input type="submit" value="'.locale('button_login', true, $locale).'" />';
	$o .= '<span style="font: bold .8em \'Bitstream Vera Sans\', Arial, Helvetica sans-serif; color: #032b4f; margin-left: 1em">cms -db</span>';
	$o .= '</p></form>';
	return $o;
}

function TagCloud($blogurl) {
	global $urlbefore, $urlafter;
	$_tags = array();
	if ($handle = opendir('./data/blog/tags')) {
		while (false !== ($file = readdir($handle))) {
			if ($file != '.' && $file != '..') {
				$_tags[] = $file;
			}
		}
		closedir($handle);
	}
	natsort($_tags);
	$max = 0;
	$tags = array();
	foreach ($_tags as $tag) {
		$content = file_get_contents('./data/blog/tags/'.$tag);
		$content = explode("\n", $content);
		$count = count($content);
		if ($count > $max) {
			$max = $count;
		}
		$tags[] = array($tag, $count);
	}
	$min = 2/10 * $max;
	$max = 8/10 * $max;
	$tagcloud = '';
	foreach ($tags as $tag) {
		$tagname = $tag[0];
		$tagcount = $tag[1];
		if ($tagcount < $min) {
			$size = 1;
		} elseif ($tagcount > $max) {
			$size = 2;
		} else {
			$size = 1 + ($tagcount / $max);
		}
		$tagcloud .= ' <a href="'.$urlbefore.$blogurl.'/tags/'.$tagname.$urlafter.'" style="font-size: '.$size.'em">'.htmlspecialchars($tagname).'</a>';
	}
	return $tagcloud;
}

function LatestBlogArticles($blogurl) {
	global $urlbefore, $urlafter;
	$articles = array();
	if ($handle = opendir('./data/blog/articles')) {
		while (false !== ($file = readdir($handle))) {
			if ($file != '.' && $file != '..') {
				$articles[] = $file;
			}
		}
		closedir($handle);
	}
	natsort($articles);
	$articles = array_reverse($articles);
	$articles = array_slice($articles, 0, 10);
	$latestblogarticles = '<ul class="latestblogarticles">';
	foreach ($articles as $article) {
		$data = file_get_contents('./data/blog/articles/'.$article.'/content');
		$data = explode("\n", $data, 5);
		$title = $data[0];
		$time = $data[2];
		$date = date('d.m.Y', $time);
		$latestblogarticles .= '<li><a href="'.$urlbefore.$blogurl.'/articles/'.$article.$urlafter.'"><span class="date">'.$date.':</span> '.htmlspecialchars($title).'</a></li>';
	}
	$latestblogarticles .= '</ul>';
	return $latestblogarticles;
}

function CompleteBlogFeed($blogurl) {
	global $urlabsolute, $locale_default;
	chdir('./admin');
	$locale = new LocalizingClass('blog', $locale_default);
	chdir('../');
	$link = '<a href="'.$urlabsolute.'/blogfeed.php?l='.$locale_default.'&amp;p='.$blogurl.'" class="blogfeed">'.locale('desc_feed-common', true, $locale).'</a>';
	return $link;
}

function AllBlogFeeds($blogurl) {
	global $urlabsolute, $locale_default;
	chdir('./admin');
	$locale = new LocalizingClass('blog', $locale_default);
	chdir('../');
	$list = '<ul class="blogfeeds">';
	$list .= '<li><a href="'.$urlabsolute.'/blogfeed.php?l='.$locale_default.'&amp;p='.$blogurl.'" class="blogfeed">'.locale('desc_feed-common', true, $locale).'</a></li>';
	$tags = array();
	if ($handle = opendir('./data/blog/tags')) {
		while (false !== ($file = readdir($handle))) {
			if ($file != '.' && $file != '..') {
				$tags[] = $file;
			}
		}
		closedir($handle);
	}
	natsort($tags);
	foreach ($tags as $tag) {
		$list .= '<li><a href="'.$urlabsolute.'/blogfeed.php?l='.$locale_default.'&amp;p='.$blogurl.'&amp;t='.urlencode($tag).'" class="blogfeed">'.sprintf(locale('desc_feed-tag', true, $locale), htmlspecialchars($tag)).'</a></li>';
	}
	$list .= '</ul>';
	return $list;
}

function ContextBlogFeeds() {
	global $urlabsolute, $locale_default, $query_string_data, $current_page;
	$blogurl = $current_page;
	chdir('./admin');
	$locale = new LocalizingClass('blog', $locale_default);
	chdir('../');
	$list = '<ul class="blogfeeds">';
	$list .= '<li><a href="'.$urlabsolute.'/blogfeed.php?l='.$locale_default.'&amp;p='.$blogurl.'" class="blogfeed">'.locale('desc_feed-common', true, $locale).'</a></li>';
	if (substr($query_string_data, 0, 4) == 'tags') {
		$arguments = explode('/', $query_string_data);
		$tag = $arguments[1];
		$list .= '<li><a href="'.$urlabsolute.'/blogfeed.php?l='.$locale_default.'&amp;p='.$blogurl.'&amp;t='.urlencode($tag).'" class="blogfeed">'.sprintf(locale('desc_feed-tag', true, $locale), htmlspecialchars($tag)).'</a></li>';
	}
	$list .= '</ul>';
	return $list;
}

function getCached($type, $func, $args, $ident='_shorturl_') {
	global $cache;
	if ($cache != 'on') {
		return call_user_func_array($func, $args);
	}
	if ($ident == '_shorturl_') {
		global $current_page;
		$ident = $current_page;
	}
	$cachefile = './data/cache/'.$type.'_'.$ident;
	if (!file_exists($cachefile)) {
		global $file_raw;
		$data = call_user_func_array($func, $args);
		if ($file_raw != '') {
			if (!@file_put_contents($cachefile, $data)) {
				$data = $data."\n".'<!-- Error while saving to cache! -->';
			}
		}
	} else {
		$data = '<!-- Cached data: '.$type.'_'.$ident.' -->'.file_get_contents($cachefile);;
	}
	return $data;
}

?>
