<?php
/*  cms-db  Copyright (C) 2007-2010 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */

if (!defined('cms-db')) {
	chdir('./admin');
	include('friendlyerror.firewall.inc.php');
	die();
}

/* Read the url index and put the data in an array */
function read_urlindex($prefix = '.') {
	global $urls, $filenames_by_url;
	
	include($prefix.'/data/settings/url.inc.php');
	$urlindex = file_get_contents($prefix.'/data/urlindex.txt');
	
	$urls = array();
	$filenames_by_url = array();
	$urlindex_exploded = explode("\n", $urlindex);
	foreach($urlindex_exploded as $line) {
		$line = explode("\t", $line, 2);
		if (count($line) == 2) {
			$urls[$line[1]] = $line[0];
			$filenames_by_url[$line[0]] = $line[1];
		}
	}
}

/* Get the short url of a page from filename */
function get_short_url($page) {
	global $urls;
	if (array_key_exists($page, $urls)) {
		$url = $urls[$page];
		return $url;
	} else {
		return false;
	}
}

/* Gets the filename of a page from the short url */
function get_filename_from_url($url) {
	global $filenames_by_url;
	if (array_key_exists($url, $filenames_by_url)) {
		$filename = $filenames_by_url[$url];
		return $filename;
	} else {
		return false;
	}
}

/* Get the complete URL of a page from the filename (needs url.inc.php to be included) */
function get_full_url($filename) {
	$shorturl = get_short_url($filename);
	if ($shorturl != false) {
		if (substr($shorturl, 0, 9) != 'REDIRECT:') {
			global $urlbefore, $urlafter;
			$url = $urlbefore.$shorturl.$urlafter;
		} else {
			$url = substr($shorturl, 9);
		}
		return $url;
	} else {
		return false;
	}
}

/* Get the type of the URL and the URL */
function get_url_data($filename) {
	$shorturl = get_short_url($filename);
	if ($shorturl != false) {
		if (substr($shorturl, 0, 9) != 'REDIRECT:') {
			$type = 'page';
			global $urlbefore, $urlafter;
			$url = $urlbefore.$shorturl.$urlafter;
		} else {
			$type = 'redirect';
			$url = substr($shorturl, 9);
		}
		return array($type, $url);
	} else {
		return false;
	}
}

$urls = false;
$filenames_by_url = false;
if (!isset($functions_url_website)) {
	read_urlindex('..');
} else {
	read_urlindex();
}

?>
