<?php
/*  cms-db  Copyright (C) 2007-2010 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */

define('cms-db', 'frontend');

/* Check if the cms is properly installed */
if (!file_exists('./data/version.txt')) {
	chdir('./admin');
	include('checkphp.inc.php');
	include('friendlyerror.firstrun.inc.php');
	chdir('../');
}

$version_installed = file_get_contents('./data/version.txt');
$version_available = file_get_contents('./admin/update/version.txt');
if ($version_installed != $version_available) {
	chdir('./admin');
	include('friendlyerror.upgrade.inc.php');
	chdir('../');
}

// very ugly hack for PHP 5.3
$default_timezone = @date_default_timezone_get();
date_default_timezone_set($default_timezone);
unset($default_timezone);

$time_start = microtime(true);

include('./data/settings/common.inc.php');

header('X-Powered-By: cms -db [http://cms-db.de/]');
header('X-Sucks: array( MSIE, Fenster );');
// Blocking xhtml for d1-online.com because of bad compression
if ($xhtml == 'on'
 && stripos($_SERVER['HTTP_ACCEPT'], 'application/xhtml+xml') !== false
 && (!isset($_SERVER['REMOTE_HOST'])
 || strpos($_SERVER['REMOTE_HOST'], 'd1-online.com') === false)) {
	header('Content-Type: application/xhtml+xml; charset=utf-8');
} else {
	header('Content-Type: text/html; charset=utf-8');
}

if (extension_loaded('mbstring')) {
	mb_internal_encoding('UTF-8');
	if (function_exists('mb_regex_encoding')) {
		mb_regex_encoding('UTF-8');
	}
	function _stripos($haystack, $needle) { return mb_stripos($haystack, $needle); }
	function _substr($str, $start, $length = false) { if ($length === false) { return mb_substr($str, $start); } else { return mb_substr($str, $start, $length); } }
	function _strlen($str) { return mb_strlen($str); }
	function _eregi_replace($pattern, $replace, $string) { return mb_eregi_replace($pattern, $replace, $string); }
} else {
	function _stripos($haystack, $needle) { return stripos($haystack, $needle); }
	function _substr($str, $start, $length = false) { if ($length === false) { return substr($str, $start); } else { return substr($str, $start, $length); } }
	function _strlen($str) { return strlen($str); }
	function _eregi_replace($pattern, $replace, $string) { return eregi_replace($pattern, $replace, $string); }
}

$functions_url_website = true;
include('functions_url.inc.php');
include('./data/settings/url.inc.php');

/* Get the needed information out of the query string */
$query_string = urldecode($_SERVER['QUERY_STRING']);

if ($query_string != '') {

	$query_string = explode('/', $query_string);

	/* Try to find the right "split point" */
	for($i = count($query_string); $i > 0; $i--) {
		$current_page = implode('/', array_slice($query_string, 0, $i));
		$query_string_data = implode('/', array_slice($query_string, $i, count($query_string)));

		/* Try to get the filename from the short url */
		$filename = get_filename_from_url($current_page);

		/* Check if the filename was found */
		if ($filename != false) {
			/* If yes, set the filename */
			$file_raw = $filename;
			break;
		}
	}

	/* Check if the filename was found */
	if ($filename == false) {
		/* Prevent the url being processed as filename */
		$file_raw = '';
	}

	unset($filename);

} else {

	$file_raw = '/01,Home/01,Home';
	$current_page = 'home';
	$query_string_data = '';

}

$file = './data/pages'.$file_raw;

$splitfile = explode('/', $file_raw);
$count = count($splitfile);
$sec = ($count > 1) ? $splitfile[1] : '';
$sub = $splitfile[$count-1];

include('./data/settings/locale.inc.php');
include('./admin/locale.inc.php');

include('functions.inc.php');

if (!isset($_GET['special']) || $_GET['special'] != 'search') {
	$FullTitle = '';
	$title_temp = substr($file, 13);
	$title = explode('/', $title_temp);
	$first = 1;
	foreach($title as $text) {
		if ($first == 0) {
			$FullTitle .= ' &gt; ';
		}
		if ($text == '01,Home') {
			$text = $home;
		} else {
			$text = substr($text, 3);
			$text = str_replace('_', ' ',$text);
			$text = str_replace('SLASH', '/',$text);
			$text = str_replace('AND', '&amp;',$text);
		}
		$FullTitle .= $text;
		$first = 0;
	}
	if ($file_raw == '/01,Home/01,Home') {
		$PageTitle = htmlentities($home);
	} else {
		if ($sub == '01,Home') {
			$PageTitle = substr($splitfile[$count-2], 3);
		} else {
			$PageTitle = substr($sub, 3);
		}
		$PageTitle = str_replace('_', ' ', $PageTitle);
		$PageTitle = str_replace('SLASH', '/', $PageTitle);
		$PageTitle = str_replace('AND', '&amp;', $PageTitle);
		$PageTitle = str_replace('.DEL', '', $PageTitle);
	}
	$FullTitle = str_replace(' &gt; '.$home, '', $FullTitle);
	$FullTitle = str_replace('.DEL', '', $FullTitle);
} else {
	chdir('./admin');
	$locale = new LocalizingClass('frontend', $locale_default);
	chdir('../');
	$FullTitle = locale('title_search',true);
	$PageTitle = locale('title_search',true);
	unset($locale);
}

if (!isset($_GET['special']) || $_GET['special'] != 'search') {
	if (file_exists($file) && is_file($file)) {
		$_content = file_get_contents($file);
		$_content = explode("\n".'EOC'."\n", $_content, 2);
		$PageContent = $_content[0];
		$_attributes = (count($_content) > 1) ? $_content[1] : '';
		unset($_content);
		$_attributes = explode("\\\\\n", $_attributes);
		$attributes = array();
		foreach ($_attributes as $attribute) {
			if ($attribute != '') {
				$attributes[] = explode('//', $attribute, 2);
			}
		}
		unset($_attributes);
	} else {
		@header('HTTP/1.0 404 Not Found');
		chdir('./admin');
		$locale = new LocalizingClass('frontend', $locale_default);
		chdir('../');
		$PageTitle = locale('title_404',true);
		$FullTitle = locale('title_404',true);
		$PageContent = '<p>'.locale('desc_404',true).'</p><p>'.locale('desc_404-sitemap',true).'</p>%%SITEMAP%%';
		$attributes = array();
		unset($locale);
		$sec = '';
		$sub = '';
	}
} else {
	$lang = (isset($_GET['lang'])) ? $_GET['lang'] : $locale_default;
	chdir('./admin');
	$locale = new LocalizingClass('frontend', $lang);
	chdir('../');
	$PageContent = doSearch($_GET['q']);
	$attributes = array();
	unset($locale);
	$sec = '';
	$sub = '';
}

// START STATS

// read the user counter
$user_file = './data/stats/users';
if (file_exists($user_file)) { $counter = file_get_contents($user_file); } else { $counter = 0; }

// create ip hash
$ip_md5 = md5($_SERVER['REMOTE_ADDR'].$_SERVER['HTTP_USER_AGENT']);
$ip = $ip_md5.'/'.time();

// load and check ip list
$ip_file = './data/stats/ip.list';
$ip_found = false;
$ip_changed = false;
$ip_time_min = time() - 86400;

// old ip list feature (uses more ram)
/*
if (file_exists($ip_file)) { $ip_list = file($ip_file); } else { $ip_list = array(); }
// could this break the php memory limit with a _very_ large ip list (multiple MB)?
foreach($ip_list as $ip_count => &$ip_line) {
	$ip_line = trim($ip_line);
	list($ip_line_code, $ip_line_time) = explode('/', $ip_line);
	if ($ip_line_time < $ip_time_min) {
		unset($ip_list[$ip_count]);
		$ip_changed = true;
	} elseif ($ip_line_code == $ip_md5) {
		$ip_found = true;
		break;
	}
}
if ($ip_changed == true) {
	$ip_list = implode("\n", $ip_list);
	file_put_contents($ip_file, $ip_list);
}
*/

if (file_exists($ip_file)) {
	$ip_list = '';
	$ip_firstline = true;
	$ip_handle = fopen($ip_file, 'r');
	while (!feof($ip_handle)) {
		$ip_line = fgets($ip_handle);
		$ip_line = trim($ip_line);
		if (strpos($ip_line, '/') !== false) {
		list($ip_line_code, $ip_line_time) = explode('/', $ip_line);
			if ($ip_line_time > $ip_time_min) {
				if (!$ip_firstline) {
					$ip_list .= "\n".$ip_line;
				} else {
					$ip_list .= $ip_line;
					$ip_firstline = false;
				}
				if ($ip_line_code == $ip_md5) {
					$ip_found = true;
				}
			} else {
				$ip_changed = true;
			}
		}
	}
	fclose($ip_handle);
	if ($ip_changed == true) {
		file_put_contents($ip_file, $ip_list);
	}
	unset($ip_list);
}

if ($ip_found == false) {
	include('detect-browser.php');
	// don't save os or user counter for bots
	if ($os != 'BOT') {
		// prepare os filename
		$os_file = str_replace(' ', '-', $os);
		$os_file = strtolower($os_file);
		$os_file = './data/stats/os/'.$os_file;
		// load content (if existing)
		if (file_exists($os_file)) { $os_content = file_get_contents($os_file); } else { $os_content = 'NONE'; }
		// save new content 
		if ($os_content != 'NONE') {
			$os_content = explode("\n", $os_content);
			$os_count = $os_content[1] + 1;
			file_put_contents($os_file, $os_content[0]."\n".$os_count);
		} else {
			file_put_contents($os_file, $os."\n1");
		}
		// update user counter
		$counter = $counter + 1;
		file_put_contents($user_file, $counter);
	}
	// prepare browser filename
	$browser_file = str_replace(array(' ', "\n"), '-', $browser);
	$browser_file = strtolower($browser_file);
	$browser_file = './data/stats/browser/'.$browser_file;
	// load content (if existing)
	if (file_exists($browser_file)) { $browser_content = file_get_contents($browser_file); } else { $browser_content = 'NONE'; }
	// save new content
	if ($browser_content != 'NONE') {
		$browser_content = explode("\n", $browser_content);
		$browser_count = $browser_content[2] + 1;
		file_put_contents($browser_file, $browser_content[0]."\n".$browser_content[1]."\n".$browser_count);
	} else {
		file_put_contents($browser_file, $browser."\n1");
	}
	// update ip list
	file_put_contents($ip_file, "\n".$ip, FILE_APPEND);
}
// END STATS

// START TEMPLATE
include('template.class.php');

$template = new template('./data/template.tpl');

$template->replace_raw('\%', '&#37;');
$template->makeIncludes('INCLUDE');
foreach($attributes as $attr) {
	list($attr_name, $attr_data) = $attr;
	if ($attr_name == 'meta') {
		list($attr_type, $attr_data) = explode('//', $attr_data, 2);
		$template->addToHead('<meta name="'.$attr_type.'" content="'.$attr_data.'" />');
	}
}
if ($template->hasToBeReplaced('PAGECONTENT')) {
	$template->replace('PAGECONTENT', $PageContent);
	unset($PageContent);
}
if ($template->hasToBeReplacedStart('CONDITION')) {
	$matches = $template->matchAll('/<p>%%CONDITION-(.*)%%<\/p>(.*)<p>%%ENDCONDITION%%<\/p>/U');
	for ($foo = 0; $foo < count($matches[1]); $foo++) {
		$condition = $matches[1][$foo];
		$condition = '$val = '.$condition.';';
		eval($condition);
		if ($val) {
			$replace = $matches[2][$foo];
		} else {
			$replace = '';
		}
		$template->replace_raw($matches[0][$foo], $replace);
	}
}
$template->replace_raw('\%', '&#37;');
$template->makeIncludes('INCLUDE');
$template->replace_raw('\%', '&#37;');
$template->setLanguage();
$template->addToHead('<link rel="stylesheet" type="text/css" href="'.$urlabsolute.'/admin/wymeditor/style.css" media="all" />');
$template->addToHead('<script type="text/javascript" src="'.$urlabsolute.'/admin/wymeditor/scripts.js"></script>');
$template->addToHead('<meta name="generator" content="cms -db" />');
if ($hinweis == 'on') {
	$template->addBefore('</body>','<div id="cms-hinweis" style="text-align: center; font-size: 0.8em; font-family: Arial, Helvetica, sans serif; margin-top: 20px"><a href="http://cms-db.de/">Powered by cms -db</a></div>'."\n\n");
} else {
	$template->addBefore('</body>','<!--Powered by cms -db (http://cms-db.de/)-->'."\n\n");
}
if ($template->hasToBeReplaced('COMPLETESUBMENU')) {
	if ($sec != '') {
		$CompleteSubMenu = getCached('pages_completesubmenu', 'createCompleteMenu', array('./data/pages/'.$sec));
	} else {
		$CompleteSubMenu = '';
	}
	$template->replace('COMPLETESUBMENU', $CompleteSubMenu);
	unset($CompleteSubMenu);
}
if ($template->hasToBeReplaced('FOLDINGSUBMENU')) {
	if ($sec != '') {
		$FoldingSubMenu = getCached('pages_foldingsubmenu', 'createFoldingMenu', array('./data/pages/'.$sec));
	} else {
		$FoldingSubMenu = '';
	}
	$template->replace('FOLDINGSUBMENU', $FoldingSubMenu);
	unset($FoldingSubMenu);
}
if ($template->hasToBeReplaced('TOPMENU')) {
	$TopMenu = getCached('pages_topmenu', 'createTopMenu', array($sec));
	$template->replace('TOPMENU', $TopMenu);
	unset($TopMenu);
}
if ($template->hasToBeReplaced('COMPLETEMENU')) {
	$CompleteMenu = getCached('pages_completemenu', 'createCompleteMenu', array('./data/pages'));
	$template->replace('COMPLETEMENU', $CompleteMenu);
	unset($CompleteMenu);
}
if ($template->hasToBeReplaced('FOLDINGMENU')) {
	$FoldingMenu = getCached('pages_foldingmenu', 'createFoldingMenu', array('./data/pages'));
	$template->replace('FOLDINGMENU', $FoldingMenu);
	unset($FoldingMenu);
}
if ($template->hasToBeReplaced('PAGETITLE')) {
	$template->replace('PAGETITLE', $PageTitle);
}
if ($template->hasToBeReplaced('FULLTITLE')) {
	$template->replace('FULLTITLE', $FullTitle);
}
if ($template->hasToBeReplaced('BREADCRUMBS')) {
	if ($_GET['special'] != 'search') {
		$BreadCrumbs = getCached('pages_breadcrumbs', 'getBreadCrumbs', array());
	} else {
		$BreadCrumbs = $FullTitle;
	}
	$template->replace('BREADCRUMBS', $BreadCrumbs);
	unset($BreadCrumbs);
}
if ($template->hasToBeReplaced('PAGESEARCH')) {
	chdir('./admin');
	$locale = new LocalizingClass('frontend', $locale_default);
	chdir('../');
	$template->replace('PAGESEARCH', '<form action="'.$urlabsolute.'/index.php" method="get">
	<div>
		<input type="hidden" name="special" value="search" />
		<input type="text" name="q" value="" size="10" maxlength="99" />
		<input type="submit" value="'.locale('button_search',true).'" />
	</div>
</form>');
	unset($locale);
}
if ($template->hasToBeReplaced('LOGINFORM')) {
	$LoginForm = LoginForm();
	$template->replace_regex('/<p>(\s*)%%LOGINFORM%%(\s*)<\/p>/U', '%%LOGINFORM%%');
	$template->replace('LOGINFORM', $LoginForm);
	$template->addToHead('<style type="text/css">/* <![CDATA[ */ #cms-db_login input { margin: 0 0 0.3em 0 } /* ]]> */</style>');
	unset($LoginForm);
}
if ($template->hasToBeReplaced('LASTEDIT')) {
	$LastEdit = LastEdit();
	$template->replace('LASTEDIT', $LastEdit);
	unset($LastEdit);
}
if ($template->hasToBeReplaced('PAGECOUNT')) {
	$PageCount = PageCount();
	$template->replace('PAGECOUNT', $PageCount);
	unset($PageCount);
}
if ($template->hasToBeReplaced('COUNTER')) {
	$template->replace('COUNTER', $counter);
}
if ($template->hasToBeReplaced('SITEMAP')) {
	$Sitemap = getCached('pages_sitemap', 'createSitemap', array('./data/pages'));
	$template->replace_regex('/<p>(\s*)%%SITEMAP%%(\s*)<\/p>/U', '%%SITEMAP%%');
	$template->replace('SITEMAP', $Sitemap);
	unset($Sitemap);
}
if ($template->hasToBeReplaced('SECTIONLIST')) {
	$SectionList = getCached('pages_sectionlist', 'SectionList', array());
	$template->replace_regex('/<p>(\s*)%%SECTIONLIST%%(\s*)<\/p>/U', '%%SECTIONLIST%%');
	$template->replace('SECTIONLIST', $SectionList);
	unset($SectionList);
}
if ($template->hasToBeReplacedStart('TAGCLOUD')) {
	$matches = $template->matchAll('/%%TAGCLOUD-(.*)%%/U');
	for ($foo = 0; $foo < count($matches[1]); $foo++) {
		$blogurl = $matches[1][$foo];
		$TagCloud = getCached('blog_tagcloud', 'TagCloud', array($blogurl), $blogurl);
		$template->replace_raw($matches[0][$foo], $TagCloud);
	}
	unset($blogurl, $TagCloud);
}
if ($template->hasToBeReplacedStart('LATESTBLOGARTICLES')) {
	$template->replace_regex('/<p>(\s*)%%LATESTBLOGARTICLES-(.*)%%(\s*)<\/p>/U', '%%LATESTBLOGARTICLES-$2%%');
	$matches = $template->matchAll('/%%LATESTBLOGARTICLES-(.*)%%/U');
	for ($foo = 0; $foo < count($matches[1]); $foo++) {
		$blogurl = $matches[1][$foo];
		$LatestBlogArticles = getCached('blog_latestblogarticles', 'LatestBlogArticles', array($blogurl), $blogurl);
		$template->replace_raw($matches[0][$foo], $LatestBlogArticles);
	}
	unset($blogurl, $LatestBlogArticles);
}
if ($template->hasToBeReplacedStart('COMPLETEBLOGFEED')) {
	$matches = $template->matchAll('/%%COMPLETEBLOGFEED-(.*)%%/U');
	for ($foo = 0; $foo < count($matches[1]); $foo++) {
		$blogurl = $matches[1][$foo];
		$CompleteBlogFeed = getCached('blog_completeblogfeed', 'CompleteBlogFeed', array($blogurl), $blogurl);
		$template->replace_raw($matches[0][$foo], $CompleteBlogFeed);
	}
	unset($blogurl, $CompleteBlogFeed);
}
if ($template->hasToBeReplacedStart('ALLBLOGFEEDS')) {
	$template->replace_regex('/<p>(\s*)%%ALLBLOGFEEDS-(.*)%%(\s*)<\/p>/U', '%%ALLBLOGFEEDS-$2%%');
	$matches = $template->matchAll('/%%ALLBLOGFEEDS-(.*)%%/U');
	for ($foo = 0; $foo < count($matches[1]); $foo++) {
		$blogurl = $matches[1][$foo];
		$AllBlogFeeds = getCached('blog_allblogfeeds', 'AllBlogFeeds', array($blogurl), $blogurl);
		$template->replace_raw($matches[0][$foo], $AllBlogFeeds);
	}
	unset($blogurl, $AllBlogFeeds);
}
if ($template->hasToBeReplacedStart('CONTEXTBLOGFEEDS')) {
	$template->replace_regex('/<p>(\s*)%%CONTEXTBLOGFEEDS%%(\s*)<\/p>/U', '%%CONTEXTBLOGFEEDS%%');
	if ($template->hasToBeReplacedStart('BLOG')) {
		$ContextBlogFeeds = getCached('blog_contextblogfeeds', 'ContextBlogFeeds', array($query_string_data), $current_page.'_'.$query_string_data);
		$template->replace('CONTEXTBLOGFEEDS', $ContextBlogFeeds);
		unset($ContextBlogFeeds);
	} else {
		$template->replace('CONTEXTBLOGFEEDS', '');
	}
}
if ($template->hasToBeReplaced('URLBEFORE')) {
	$template->replace('URLBEFORE', $urlbefore);
}
if ($template->hasToBeReplaced('URLAFTER')) {
	$template->replace('URLAFTER', $urlafter);
}
if ($template->hasToBeReplaced('URLABSOLUTE')) {
	$template->replace('URLABSOLUTE', $urlabsolute);
}
if ($template->hasToBeReplaced('COMPLETEURL')) {
	$protocol = $_SERVER['HTTPS'] == 'on' ? 'https' : 'http';
	$port = $_SERVER['SERVER_PORT'] == 80 ? '' : ':'.$port;
	$completeurl = $protocol.'://'.$_SERVER['HTTP_HOST'].$port.$_SERVER['REQUEST_URI'];
	$template->replace('COMPLETEURL', $completeurl);
}
if ($template->hasToBeReplacedStart('MAILFORM')) {
	$template->replace_regex('/<p>(\s*)%%MAILFORM-(.*)%%(\s*)<\/p>/U', '%%MAILFORM-$2%%');
	$matches = $template->matchAll('/%%MAILFORM-(.*)%%/U');
	for ($foo = 0; $foo < count($matches[1]); $foo++) {
		$mailaddress = $matches[1][$foo];
		ob_start();
		include('contact.php');
		$MailForm = ob_get_contents();
		ob_end_clean();
		$template->replace_raw($matches[0][$foo], $MailForm);
	}
	unset($mailaddress, $MailForm);
}
$template->makeIncludes('LATEINCLUDE');
if ($template->hasToBeReplacedStart('BLOG')) {
	$template->replace_regex('/<p>(\s*)%%BLOG-(.*)%%(\s*)<\/p>/U', '%%BLOG-$2%%');
	$matches = $template->matchAll('/%%BLOG-(.*)%%/U');
	if (count($matches[1]) > 0) {
		for ($foo = 0; $foo < count($matches[1]); $foo++) {
			$blogattr = $matches[1][$foo];
			$blogattr = explode('-', $blogattr);
			include('blog.php');
			$template->replace_raw($matches[0][$foo], $blog);
		}
	} else {
		$blogattr = array();
		include('blog.php');
		$template->replace('/<p>(\s*)%%BLOG%%(\s*)<\/p>/U', '%%BLOG%%');
		$template->replace('BLOG', $blog);
	}
	unset($blog);
} elseif ($template->hasToBeReplaced('GUESTBOOK')) {
	ob_start();
	include('gb.php');
	$GuestBook = ob_get_contents();
	ob_end_clean();
	$template->replace_regex('/<p>(\s*)%%GUESTBOOK%%(\s*)<\/p>/U', '%%GUESTBOOK%%');
	$template->replace('GUESTBOOK', $GuestBook);
	unset($Guestbook);
}
$template->replace_raw('&#37;', '%');

$template->output();

// END TEMPLATE

$time_end = microtime(true);
$time = $time_end - $time_start;
if (function_exists('memory_get_peak_usage')) {
	echo "\n".'<!-- Parsed in '.$time.' seconds with a memory peak of '.memory_get_peak_usage().' Bytes, current memory usage are '.memory_get_usage().' Bytes -->';
} else {
	echo "\n".'<!-- Parsed in '.$time.' seconds with memory usage of '.memory_get_usage().' Bytes -->';

}
?>
