<?php
/*  cms-db  Copyright (C) 2007-2010 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */

if (!defined('cms-db')) {
	chdir('./admin');
	include('friendlyerror.firewall.inc.php');
	die();
}

class template {

	protected $content;

	function __construct($file) {
		@$this->content = file_get_contents($file);
		if ($this->content == false) {
			header('Content-type: text/html');
			echo '<b>Error:</b> Failed to open template file.';
			die();
		}
	}

	public function replace($title, $value) {
		// Replace all %%TITLE%% with %%VALUE%%
		$this->content = str_replace('%%'.$title.'%%', $value, $this->content);
	}

	public function replace_raw($search, $replace) {
		$this->content = str_replace($search, $replace, $this->content);
	}

	public function replace_regex($title, $value) {
		// Alle TITLE mit regulären Ausdrücken durch VALUE ersetzen
		$this->content = preg_replace($title, $value, $this->content);
	}

	function doInclude($inc) {
		if(file_exists('./data/includes/'.$inc)) {
			ob_start();
			include('./data/includes/'.$inc);
			$Include = ob_get_contents();
			ob_end_clean();
		} else {
			$Include = '<b>ERROR: Couldn\'t find include file "'.$inc.'"!</b>';
		}
		return $Include;
	}

	public function makeIncludes($name) {
		$matches = array();
		preg_match_all('/<p>(\s*)%%'.$name.'-(.*)%%(\s*)<\/p>/U', $this->content, $matches);
		for ($i = 0; $i < count($matches[2]); $i++) {
			$include = $this->doInclude($matches[2][$i]);
			$this->content = str_replace($matches[0][$i], $include, $this->content);
		}
		$matches = array();
		preg_match_all('/%%'.$name.'-(.*)%%/U', $this->content, $matches);
		for ($i = 0; $i < count($matches[1]); $i++) {
			$include = $this->doInclude($matches[1][$i]);
			$this->content = str_replace($matches[0][$i], $include, $this->content);
		}
	}

	public function setLanguage() {
		// Set the language from %%FORCELANGUAGE-langcode%%
		$this->content = preg_replace_callback(
			'/<p>(\s*)%%FORCELANGUAGE-(.*)%%(\s*)<\/p>/U',
			create_function(
				'$match',
				'global $locale_default; $locale_default = $match[2]; return \'\';'
			),
			$this->content
		);
		$this->content = preg_replace_callback(
			'/%%FORCELANGUAGE-(.*)%%/U',
			create_function(
				'$match',
				'global $locale_default; $locale_default = $match[1]; return \'\';'
			),
			$this->content
		);
	}

	public function addToHead($value) {
		$this->content = str_replace('</head>', $value."\n".'</head>', $this->content);
	}

	public function addBefore($title, $value) {
		$this->content = str_replace($title, $value.$title, $this->content);
	}

	public function addAfter($title, $value) {
		$this->content = str_replace($title, $title.$value, $this->content);
	}

	public function matchAll($regex) {
		$matches = array();
		preg_match_all($regex, $this->content, $matches);
		return $matches;
	}

	public function output() {
		echo $this->content;
	}

	public function hasToBeReplaced($foo) {
		$pos = strpos($this->content, '%%'.$foo.'%%');
		if ($pos === false) {
			return false;
		} else {
			return true;
		}
	}

	public function hasToBeReplacedStart($foo) {
		$pos = strpos($this->content, '%%'.$foo);
		if ($pos === false) {
			return false;
		} else {
			return true;
		}
	}

	public function stringExists($foo) {
		$pos = strpos($this->content, $foo);
		if ($pos === false) {
			return false;
		} else {
			return true;
		}
	}

}
?>
